var fullcalendarScheduler;
$(document).ready(function () {

  //console.log("constructor_1");

  // $('#calendar').fullCalendar({
  //   header: {
  //     left: 'prev,next today',
  //     center: 'title',
  //     right: 'month,agendaWeek,agendaDay,listWeek'
  //   },
  //   defaultDate: Date(),
  //   navLinks: true, // can click day/week names to navigate views
  //   weekNumbers: true,
  //   weekNumbersWithinDays: true,
  //   weekNumberCalculation: 'ISO',
  //   editable: true,
  //   allDay: true,
  //   events:[ {
  //   title: 'Default Event',
  //       start: '2018-08-07',
  //       end: '2018-08-10'
  //   }],
  //   eventLimit: true, // allow "more" link when too many events
  //   eventDrop: function(event, delta, revertFunc) {
  //     $(formField().DTSTART).val(event.start.format());
  //   }
  // });

  var initialLocaleCode = 'en-gb';
  var now = new Date().setMinutes(0);

  fullcalendarScheduler = new FullCalendar.Calendar(document.getElementById('fullcalendar_scheduler'), {
    schedulerLicenseKey: 'GPL-My-Project-Is-Open-Source',
    plugins: ['interaction', 'resourceTimeline', 'rrule'],
    defaultDate: now,
    timeZone: 'local',
    editable: true, // enable draggable events
    aspectRatio: 1.8, // default: 1.35
    scrollTime: '00:00', // undo default 6am scrollTime

    header: {
      left: 'promptCourse,promptTrainer,promptRoom today prev,next',
      center: 'title',
      right: 'zoomIn,zoomOut'
    },

    customButtons: {
      // zoomIn: {
      //   text: '<',
      // },
      // zoomOut: {
      //   text: '>',
      // },
      promptCourse: {
        text: '+Course',
        click: function () {
          var title = prompt('Course name');
          if (title) {
            $('#fullcalendar_scheduler').fullCalendar(
              'addResource',
              { title: title },
              true // scroll to the new resource?
            );
          }
        }
      },
      promptTrainer: {
        text: '+Trainer',
        click: function () {
          var title = prompt('Trainer name');
          if (title) {
            $('#fullcalendar_scheduler').fullCalendar(
              'addResource',
              { title: title },
              true // scroll to the new resource?
            );
          }
        }
      },
      promptRoom: {
        text: '+Room',
        click: function () {
          var title = prompt('Room name');
          if (title) {
            $('#fullcalendar_scheduler').fullCalendar(
              'addResource',
              { title: title },
              true // scroll to the new resource?
            );
          }
        }
      }
    },

    //defaultView: 'timeline3Days',
    //defaultView: 'timeline1Day',
    //defaultView: 'timeline',
    defaultView: 'resourceTimelineDay',

    // visibleRange: function (currentDate) {
    //   return {
    //     start: currentDate, //window.visibleRangeStartDate,
    //     end: currentDate.clone().add(3, 'days') //window.visibleRangeEndDate
    //   };
    // },

    // validRange: function(nowDate) {
    //   return {
    //     start: dateAdd(nowDate, -3, 'days'), //window.visibleRangeStartDate,
    //     end: dateAdd(nowDate, 3, 'days') //window.visibleRangeEndDate
    //   };
    // },

    // views: {
    //   resourceTimeline2Days: {
    //     type: 'resourceTimeline',
    //     duration: { days: 2 }
    //   },
    //   resourceTimeline3Days: {
    //     type: 'resourceTimeline',
    //     duration: { days: 3 }
    //   },
    //   resourceTimeline: {
    //     // options apply to resourceTimeline views (resourceTimelineDay, resourceTimelineWeek, resourceTimelineMonth)
    //     visibleRange: function (currentDate) {
    //       return {
    //         start: window.visibleRangeStartDate,
    //         end: window.visibleRangeEndDate
    //       };
    //     },
    //   },
    //   dayGrid: {
    //     // options apply to dayGridDay, dayGridWeek and dayGridMonth views
    //   },
    //   timeGrid: {
    //     // options apply to timeGridDay and timeGridWeek views
    //   },
    //   week: {
    //     // options apply to dayGridWeek and timeGridWeek views
    //   },
    //   day: {
    //     // options apply to dayGridDay and timeGridDay views
    //   }

    // },

    resourceAreaWidth: '20%',
    resourceGroupField: 'resourceType',

    // If refetchResourcesOnNavigate is set to true, the network request will
    // be made with additional parameters: the start/end date of the newly
    // visible window of time, as well as the calendar’s timezone
    //
    // example request: /resource_planner/resources.json?start=2017-12-01&end=2017-01-12&timezone=UTC

    refetchResourcesOnNavigate: true,
    resources: {
      url: '/resource_planner/resources.json',
      type: 'GET',
    },

    eventSources: getEventSources(),

    // Callbacks

    resourceRender: function (renderInfo) {
      $(renderInfo.el).on('click', function () {
        resourceSelectedHandler(renderInfo);
      });
    },

    viewSkeletonRender: function (info) {
      // View’s non-date-related DOM structure has been rendered.
      // This callback will get triggered when the initial view renders or when
      // the user changes the view, but before the datesRender callback fires.
    },

    datesRender: function (info) {
      // All date/time cells have been rendered.
      // This triggers after viewSkeletonRender callback but before the eventRender callbacks.

      attachTimelineManipulationHandlers();
      renderScrollBar();
      initialiseHighlighterbarTooltip();

      if (typeof window.eventsArray !== 'undefined') {
        renderEvents(window.eventsArray, window.StartingDate, window.endingDate);
      }

      renderSelectedResources();
    },

    eventRender: function (info) {
    },

    eventDrop: function (event, delta, revertFunc) {
      if (!confirm(event.title + " was changed to " + event.start.format() + "\nAre you sure about this change?")) {
        revertFunc();
      }
    },

  }); // end fullcalendar() initialisation

  fullcalendarScheduler.render();

  // build the locale selector's options
  $.each(FullCalendarLocalesAll, function (locale) {
    $('#locale-selector').append(
      $('<option/>')
        .attr('value', FullCalendarLocalesAll[locale].code)
        .prop('selected', FullCalendarLocalesAll[locale].code == initialLocaleCode)
        .text(FullCalendarLocalesAll[locale].code)
    );
  });
  setLocaleCode(initialLocaleCode);

  // Attach date/time selectors to the page
  $('.datetimepick').datetimepicker({
    format: 'Y-m-d H:i',
  });

  $('.datepick').datetimepicker({
    timepicker: false,
    format: 'Y-m-d',
  });

  // Initialise the doubleScroll
  renderScrollBar();

  //

  /********************************************* Locale Handlers *********************************************/
  // when the selected option changes, dynamically change the calendar option
  $('#locale-selector').on('change', function () {
    if (this.value) {
      setLocaleCode(this.value);
    }
  });
  /*_________________________________________________________________________________________________________*/

  /******************************************** EVENT HANDLERS ***********************************************/

  /*************************************** Start Date Change/Input Handlrers  *******************************************/
  $(formField().DTSTART).on('change', function () {
    startDateInput();
  });

  $(formField().DTSTART).on('input', function () {
    startDateInput();
  });

  /************************************* End Date Change/Input Handlrers ****************************************/
  $(formField().DTEND).on('change', function () {
    endDateInput();
  });

  $(formField().DTEND).on('input', function () {
    endDateInput();
  });

  /************************************ Change/Input Duration Handlers *****************************************/
  $(formField().DURATION).on('change', function () {
    durationInput();
  });

  $(formField().DURATION).on('input', function () {
    durationInput();
  });

  /************************************** Duration Minutes/Hours Handlers **************************************/
  /* These two listeners should be kept in sync */
  $(formField().DURATION_UNITS).on('change', function () {
    durationUnitInput();
  });

  /******************************************* Reccuring Eevents Handlers **************************************/
  /*************************************************** daily ***************************************************/
  /**** recurence_pattern ****/
  $('.recurring_event_data.daily input').on('input', function () {
    switch ($(this).val()) {
      case 'every_n_days':                                          // every_n_days radio button clicked
        $("#resource_planner_event_count").val("1");
        break;
      case 'every_weekday':                                         // every_weekday radio button clicked
        $("#resource_planner_event_count").val("");
        break;
      default:                                                        // the number 'n' days is entered
        var values = parseInt($(this).val());
        if ((isNaN(values)) || (values == 0)) {
          $("#resource_planner_event_count").val("");                // not a number or zero not allowed
        } else {                                                   // a valid number has been typed
          document.getElementById("resource_planner_event_count_every_n_days").checked = true;  // check "every_n_days" Radio Button
        }
    }
    recurenceInputStatus("daily");   // check if all required fields are present
  });

  /*___________________________________________________________________________________________________________*/
  /************************************************** Weekly ***************************************************/
  /**** recurence_pattern ****/
  $('.recurring_event_data.weekly input').on('input', function () {       // every_n_week(s) field was typed
    var values = parseInt($(this).val());
    if ((isNaN(values)) || (values == 0)) {                               // not a number or zero not allowed
      $('.recurring_event_data.weekly input').val("");                    // set 'every_n_week(s)' field to ""
    } else {                                                              // a valid number has been typed
    }
    recurenceInputStatus("weekly");    // check if all required fields are present
  });

  $(".day_buttons label").on("click", function () {         // one of the days of the week was selected
    recurenceInputStatus("weekly");    // check if all required fields are present
  });

  /*___________________________________________________________________________________________________________*/
  /************************************************** Monthly **************************************************/
  /**** recurence_pattern ****/
  $('.recurring_event_data.monthly input').on('input', function () {               // every_n_week(s) field was typed
    switch ($(this).val()) {
      case 'every_month':
        var selectedMonthDays = $('.recurring_event_data.monthly label.day-button-selected');
        selectedMonthDays.removeClass('day-button-selected');                     // every_n_month(s) radio button was clicked
        $('input[name="resource_planner_event[count]"]').val("1");
        break;
      case 'every_month_day':
        $('input[name="resource_planner_event[count]"]').val("");                 // every_weekday radio button clicked
        break;
      default:                                                                    // the number 'n' days is typed
        selectedMonthDays = $('.recurring_event_data.monthly label.day-button-selected');
        selectedMonthDays.removeClass('day-button-selected');
        var values = parseInt($(this).val());
        if ((isNaN(values)) || (values == 0)) {                                   // not a number or zero not allowed
          $('input[name="resource_planner_event[count]"]').val("");
        } else {                                                                  // a valid number has been typed
          document.getElementById("resource_planner_event_count_every_month").checked = true;  // set "every 'n' month(s)" Radio Button active
        }
    }
    recurenceInputStatus("monthly");   // check if all required fields are present
  });

  // How often a day of the week should be used in a month
  $('#resource_planner_event_bymonthday').on('change', function () {
    document.getElementById("resource_planner_event_count_every_month").checked = true;  // set "every 'n' month(s)" Radio Button active
    $('input.resource_planner_event_day_of_month').removeAttr('checked');
    $('.day-button-selected').removeClass('day-button-selected');

    recurenceInputStatus("monthly");   // check if all required fields are present
  });
  /******************************************************************/

  // What day of the week should be used
  $('#resource_planner_event_bymonthday_day').on('change', function () {
    document.getElementById("resource_planner_event_count_every_month").checked = true;  // set "every 'n' month(s)" Radio Button active
    $('input.resource_planner_event_day_of_month').removeAttr('checked');
    $('.day-button-selected').removeClass('day-button-selected');

    recurenceInputStatus("monthly");   // check if all required fields are present
  });
  /******************************************************************/

  // one of the day_of_month was checked or unchecked
  $(".monthly_day_buttons label").on("click", function () {
    var checkbox = $(this).prev('input:checkbox:first');
    if (!checkbox.is(':checked')) {                                          // if one of the checked days was unchecked
      $(this).addClass('day-button-selected');
    }

    $('input[name="resource_planner_event[count]"]').val("");
    document.getElementById("resource_planner_event_count_every_month_day").checked = true; // set the Radio Button active

    recurenceInputStatus("monthly");   // check if all required fields are present
  });
  /******************************************************************/

  // What day of the week should be used
  $('#resource_planner_event_bymonthday_day').on('change', function () {
    document.getElementById("resource_planner_event_count_every_month").checked = true;  // set "every 'n' month(s)" Radio Button active
    $('.day-button-selected').removeClass('day-button-selected');
    recurenceInputStatus("monthly");   // check if all required fields are present
  });

  /*___________________________________________________________________________________________________________*/

  /***********************************************************************************************************/
  /**** range_of_recurence ****/
  $('.range_of_recurence input').on('input', function () {
    switch ($(this).val()) {
      case 'no_end_date':                                        // no_end_date option selected
        $("#resource_planner_event_until_count").val("");        // make sure the "every [n] days" field is empty
        $("#repeat_until").val("");                              // make sure the "repeat until" field is empty
        break;
      case 'create_n_events':                                   // create 'n' events radio button selected
        $("#resource_planner_event_until_count").val("1");
        $("#repeat_until").val("");                             // make sure the "repeat until" field is empty
        break;
      case 'repeat_until':                                      // repeat untill radio button selected
        $("#resource_planner_event_until_count").val("");       // make sure the "every [n] days" field is empty
        break;
      default:
        var values = parseInt($(this).val());
        if ((isNaN(values)) || (values == 0)) {                 // not a number or zero not allowed
          $("#resource_planner_event_until_count").val("");
        } else {                                                // a valid number has been typed
          document.getElementById("resource_planner_event_until_create_n_events").checked = true;  // set "every 'n' month(s)" Radio Button to checked
          $("#repeat_until").val("");                             // make sure the "repeat until" field is empty
        }
    }
    recurenceInputStatus($.trim($('#resource_planner_event_rrule').val()));    // check if all required fields are present
  });

  // repeat until date selection
  $('#repeat_until').on('change', function () {
    $("#resource_planner_event_until_count").val("");
    document.getElementById("resource_planner_event_until_repeat_until").checked = true;

    recurenceInputStatus($.trim($('#resource_planner_event_rrule').val()));    // check if all required fields are present
  });

}); // end $(document).ready()


//
// Common/Helper functions
//
/*___________________________________________________________________________________________________________*/
function setLocaleCode(localeCode) {
  $.datetimepicker.setLocale(localeCode);
  fullcalendarScheduler.setOption('locale', localeCode);
}

/*___________________________________________________________________________________________________________*/
function getEventWindowHeight() {
  var view = fullcalendarScheduler.view;
  return view.timeAxisTbody.clientHeight;
}

/*___________________________________________________________________________________________________________*/
function getEventWindowWidth() {
  var view = fullcalendarScheduler.view;
  return view.timeAxisTbody.clientWidth;
}

/*___________________________________________________________________________________________________________*/
function getEventWindowHours() {
  var view = fullcalendarScheduler.view;
  var start = view.currentStart;
  var end = view.currentEnd;
  var days = end.diff(start, "days");
  var eventWindowHours = 24 * days;
  return eventWindowHours;
}

/*___________________________________________________________________________________________________________*/
function renderScrollBar() {
  // if ($('#doubleScroll_padding').length == 0) {
  //   $('#fullcalendar_scheduler tbody.fc-body td.fc-resource-area div.fc-scroller').prepend($('<div id="doubleScroll_padding"></div>'));
  // }

  $('#fullcalendar_scheduler tbody.fc-body td.fc-resource-area div.fc-scroller').doubleScroll({
    onlyIfScroll: false,      // top scrollbar is not shown if the bottom one is not present
    resetOnWindowResize: true // recompute the top ScrollBar requirements when the window is resized
  });

  $('#fullcalendar_scheduler tbody.fc-body td.fc-time-area div.fc-scroller').doubleScroll({
    onlyIfScroll: true,       // top scrollbar is not shown if the bottom one is not present
    resetOnWindowResize: true // recompute the top ScrollBar requirements when the window is resized
  });
}

/*========================================================================================================*/
/*  check presence of all required fields for recurence                                                  */
/*________________________________________________________________________________________________________*/
function recurenceInputStatus(recurencePattern) {

  $('.highlighter').remove();                             // clear previous rendered evenets

  var start_date = $.trim($(formField().DTSTART).val());
  var duration = $.trim($(formField().DURATION).val());
  var durationUnits = $.trim($(formField().DURATION_UNITS).val());

  if (start_date == "") {
    $(formField().DTSTART).addClass("input_warning");
  } else {
    $(formField().DTSTART).removeClass("input_warning");
  }

  if (duration == "") {
    $(formField().DURATION).addClass("input_warning");
  } else {
    $(formField().DURATION).removeClass("input_warning");
  }

  if (durationUnits == "") {
    $("#durationUnits").addClass("input_warning");
  } else {
    $("#durationUnits").removeClass("input_warning");
  }

  testStatus(recurencePattern);

  if (start_date == "" || duration == "" || durationUnits == "") {
    return false;                                                         // some fields are missing
  }

  var recurenceObject = {        // This object will be passed over to the prepareEvents Function
    startDate: start_date,
    eventDuration: duration,
    durationUnits: durationUnits,
    howOften: "",                 // Every how many days/weeks/months ?
    when: [],                     // Array icluding the week days, or month days (02, 07, 15,...)
    nrOfEvents: "",               // Number of events
    endDate: "",
  }

  var i;
  var values;

  // Check the presence of the recurence pattern section
  switch (recurencePattern) {
    case "daily":                                                         // check the presence of the DAILY recurence pattern fields
      var buttonChecked = $('.recurring_event_data.daily input#resource_planner_event_count_every_n_days');
      if (buttonChecked[0].checked) {        // is every_n_days button is checked...
        var nrDays = $('.recurring_event_data.daily input#resource_planner_event_count').val(); // every_n_days button is checked
        values = parseInt(nrDays);
        if (isNaN(values)) {
          $(".recurring_event_data.daily").addClass("input_warning");
          return false;                                              // 'n' of every 'n' days is missing
        } else {
          $(".recurring_event_data.daily").removeClass("input_warning");
          recurenceObject.howOften = values;
          break;                                                       // 'n' of every 'n' days is present
        }
      } else {                                                           // every_n_days button is not checked
        buttonChecked = $('.recurring_event_data.daily input#resource_planner_event_count_every_weekday');
        if (buttonChecked[0].checked) {                                 // is every_weekday butoon is checked
          recurenceObject.howOften = 1;
          $(".recurring_event_data.daily").removeClass("input_warning");
          break;                                                         // every_weekday butoon is checked
        } else {
          $(".recurring_event_data.daily").addClass("input_warning");
          return false;                                                  // every_weekday butoon is not checked
        }
      }
    case "weekly":                                                        // check the presence of the WEEKLY recurence pattern fields
      var every_n_weeks = $('.recurring_event_data.weekly input').val();            // is 'n' for every_n_weeks field was typed ?
      values = parseInt(every_n_weeks);
      if (isNaN(values)) {
        $(".recurring_event_data.weekly").addClass("input_warning");
        return false;                                                 // if 'n' not a number, e.g. n = "", then stop checking further fields
      } else {
        $(".recurring_event_data.weekly").removeClass("input_warning");                                             // check next field (day of the week)
        recurenceObject.howOften = values;
        var selectedWeekDays = $('.recurring_event_data.weekly label.day-button-selected');
        if (!selectedWeekDays.length) {                                 // if length = 0 (no day of week was selected)
          $(".recurring_event_data.weekly").addClass("input_warning");
          return false;                                               // some fields are missing
        } else {
          $(".recurring_event_data.weekly").removeClass("input_warning");
          for (i = 0; i < selectedWeekDays.length; i++) {
            recurenceObject.when[i] = selectedWeekDays[i].innerHTML;
          }
          break;
        }

        //break;
      }
    //}
    case "monthly":                                                   // check the presence of the MONTHLY recurence pattern fields
      buttonChecked = $('.recurring_event_data.monthly input#resource_planner_event_count_every_month');
      if (buttonChecked[0].checked) {                             // every_n_month button was checked
        var every_n_months = $('.recurring_event_data.monthly input#resource_planner_event_count').val();
        values = parseInt(every_n_months);
        if (isNaN(values)) {
          $(".recurring_event_data.monthly").addClass("input_warning");
          return false;                                         // if 'n' not a number, e.g. n = "", then stop checking further fields
        } else {
          $(".recurring_event_data.monthly").removeClass("input_warning");
          recurenceObject.howOften = values;
          var cycle = $('.recurring_event_data.monthly select#resource_planner_event_bymonthday').val();
          var whichDay = $('.recurring_event_data.monthly select#resource_planner_event_bymonthday_day').val();
          recurenceObject.when[0] = cycle;
          recurenceObject.when[1] = whichDay;
          break;
        }
      } else {
        var selectedCheckedButton = $('.recurring_event_data.monthly input#resource_planner_event_count_every_month_day');   // is the day_of_month button checked ?
        if (!selectedCheckedButton[0].checked) {                                        // if length = 0 (no day of week was selected)
          $(".recurring_event_data.monthly").addClass("input_warning");
          return false;                                                                // some fields are missing
        } else {
          var selectedMonthDays = $('.recurring_event_data.monthly label.day-button-selected');
          if (!selectedMonthDays.length) {                                              // if length !== 0 (day of week was selected)
            $(".recurring_event_data.monthly").addClass("input_warning");
            return false;                                                               // some fields are missing
          } else {
            for (i = 0; i < selectedMonthDays.length; i++) {
              recurenceObject.when[i] = selectedMonthDays[i].innerHTML;
            }
            $(".recurring_event_data.monthly").removeClass("input_warning");
            break;
          }
        }
      }
  }


  // checking the presence of the range_of_recurence fields section
  var selectedButton = $('.range_of_recurence input#resource_planner_event_until_no_end_date');
  if (selectedButton[0].checked) {
    var datum = moment(start_date);
    var endDatum = datum.add(6, 'months');
    recurenceObject.endDate = endDatum.format();
    prepareEvents(recurenceObject, recurencePattern);
    $(".range_of_recurence").removeClass("input_warning");
    return true;                                                // all required fields are present
  }

  selectedButton = $('.range_of_recurence input#resource_planner_event_until_create_n_events');        // was create_n_events button checked ?
  if (selectedButton[0].checked) {                                                                      // YES, create_n_events button was checked
    var create_n_events = $('.range_of_recurence input#resource_planner_event_until_count').val();     // check presence of 'n' events number
    values = parseInt(create_n_events);
    if (isNaN(values)) {                                                                                // is 'n' number of events present ?
      $(".range_of_recurence").addClass("input_warning");
      return false;                                                               // NO, number of 'n' is not present, stop checking
    } else {
      recurenceObject.nrOfEvents = values;                                        // Number of events
      $(".range_of_recurence").removeClass("input_warning");
      prepareEvents(recurenceObject, recurencePattern);
      return true;                                                                 // all required fields are present
    }
  }

  selectedButton = $('.range_of_recurence input#resource_planner_event_until_repeat_until');          // was repeat button until checked ?
  if (selectedButton[0].checked) {                                                                   // Yes, check presence of the until date
    var untilDate = $('.range_of_recurence input#repeat_until.form-control.date-field.datepick');
    var validDate = Date.parse(untilDate[0].value)
    if (validDate) {
      var begin_date = new Date(moment(recurenceObject.startDate).startOf('day'));
      var newUntilDate = new Date(untilDate[0].value);
      if (newUntilDate < begin_date) {
        untilDate[0].value = "";
        $(".range_of_recurence").addClass("input_warning");
        return false;
      } else {
        recurenceObject.endDate = untilDate[0].value;
        prepareEvents(recurenceObject, recurencePattern);
        return true;                                                               // all required fields are present
      }
    } else {
      $(".range_of_recurence").addClass("input_warning");
      return false;                                                              // some fields are missing
    }
  } else {
    $(".range_of_recurence").addClass("input_warning");
    return false;                                                                 // some fields are missing
  }
}
// end function recurenceInputStatus
/*========================================================================================================*/

function noReccurence() {
  if ($.trim($('#resource_planner_event_rrule').val()) == "no_repeat") {
    return true;                      // all required fields are present
  }
}
/*========================================================================================================*/

function sleep(ms) {
  return new Promise(resolve => setTimeout(resolve, ms));
}

/*========================================================================================================*/
function testStatus(recurencePattern) {

  var start_date = $.trim($(formField().DTSTART).val());
  var duration = $.trim($(formField().DURATION).val());
  var durationUnits = $.trim($(formField().DURATION_UNITS).val());

  var recurenceObject = {        // This object will be passed over to the recurence event render Function
    startDate: start_date,
    eventDuration: duration,
    durationUnits: durationUnits,
    howOften: "",                 // Every how many days/weeks/months ?
    when: [],                     // Array icluding the week days, or month days (02, 07, 15,...)
    nrOfEvents: "",               // Number of events
    endDate: "",
  }

  var values;

  // Check the presence of the recurence pattern section
  switch (recurencePattern) {
    case "daily":                                                         // check the presence of the DAILY recurence pattern fields
      var buttonChecked = $('.recurring_event_data.daily input#resource_planner_event_count_every_n_days');
      if (buttonChecked[0].checked) {        // is every_n_days button is checked...
        var nrDays = $('.recurring_event_data.daily input#resource_planner_event_count').val(); // every_n_days button is checked
        values = parseInt(nrDays);
        if (isNaN(values)) {
          $(".recurring_event_data.daily").addClass("input_warning");
        } else {
          $(".recurring_event_data.daily").removeClass("input_warning");                                // 'n' of every 'n' days is present
        }
      } else {                                                           // every_n_days button is not checked
        buttonChecked = $('.recurring_event_data.daily input#resource_planner_event_count_every_weekday');
        if (buttonChecked[0].checked) {                                 // is every_weekday butoon is checked
          $(".recurring_event_data.daily").removeClass("input_warning");  // every_weekday butoon is checked
        } else {
          $(".recurring_event_data.daily").addClass("input_warning");     // every_weekday butoon is not checked
        }
      }
      break;

    case "weekly":                                                        // check the presence of the WEEKLY recurence pattern fields
      var every_n_weeks = $('.recurring_event_data.weekly input').val();            // is 'n' for every_n_weeks field was typed ?
      values = parseInt(every_n_weeks);
      if (isNaN(values)) {
        $(".recurring_event_data.weekly").addClass("input_warning");
      } else {
        $(".recurring_event_data.weekly").removeClass("input_warning");                                             // check next field (day of the week)
        recurenceObject.howOften = values;
        var selectedWeekDays = $('.recurring_event_data.weekly label.day-button-selected');
        if (!selectedWeekDays.length) {                                 // if length = 0 (no day of week was selected)
          $(".recurring_event_data.weekly").addClass("input_warning");  // some fields are missing
        } else {
          $(".recurring_event_data.weekly").removeClass("input_warning");
        }
      }
      break;

    case "monthly":                                                   // check the presence of the MONTHLY recurence pattern fields
      buttonChecked = $('.recurring_event_data.monthly input#resource_planner_event_count_every_month');
      if (buttonChecked[0].checked) {                             // every_n_month button was checked
        var every_n_months = $('.recurring_event_data.monthly input#resource_planner_event_count').val()
        values = parseInt(every_n_months);
        if (isNaN(values)) {
          $(".recurring_event_data.monthly").addClass("input_warning"); // if 'n' not a number, e.g. n = "", then stop checking further fields
        } else {
          $(".recurring_event_data.monthly").removeClass("input_warning");
        }
      } else {
        var selectedCheckedButton = $('.recurring_event_data.monthly input#resource_planner_event_count_every_month_day');   // is the day_of_month button checked ?
        if (!selectedCheckedButton[0].checked) {                                        // if length = 0 (no day of week was selected)
          $(".recurring_event_data.monthly").addClass("input_warning");                 // some fields are missing
        } else {
          var selectedMonthDays = $('.recurring_event_data.monthly label.day-button-selected');
          if (!selectedMonthDays.length) {                                              // if length !== 0 (day of week was selected)
            $(".recurring_event_data.monthly").addClass("input_warning");               // some fields are missing
          } else {
            $(".recurring_event_data.monthly").removeClass("input_warning");
          }
        }
      }
      break;
  }


  // checking the presence of the range_of_recurence fields section
  var selectedButton = $('.range_of_recurence input#resource_planner_event_until_no_end_date');
  if (selectedButton[0].checked) {
    $(".range_of_recurence").removeClass("input_warning");       // all required fields are present
    return true;
  }

  selectedButton = $('.range_of_recurence input#resource_planner_event_until_create_n_events');        // was create_n_events button checked ?
  if (selectedButton[0].checked) {                                                                      // YES, create_n_events button was checked
    var create_n_events = $('.range_of_recurence input#resource_planner_event_until_count').val();     // check presence of 'n' events number
    values = parseInt(create_n_events);
    if (isNaN(values)) {                                                                                // is 'n' number of events present ?
      $(".range_of_recurence").addClass("input_warning");                                              // NO, number of 'n' is not present, stop checking
    } else {
      $(".range_of_recurence").removeClass("input_warning");                                           // all required fields are present
      return true;
    }
  }

  selectedButton = $('.range_of_recurence input#resource_planner_event_until_repeat_until');          // was repeat button until checked ?
  if (selectedButton[0].checked) {                                                                   // Yes, check presence of the until date
    var untilDate = $('.range_of_recurence input#repeat_until.form-control.date-field.datepick');
    var validDate = Date.parse(untilDate[0].value)
    if (validDate) {
      var begin_date = new Date(moment(recurenceObject.startDate).startOf('day'));
      var newUntilDate = new Date(untilDate[0].value);
      if (newUntilDate < begin_date) {
        untilDate[0].value = "";
        $(".range_of_recurence").addClass("input_warning");
      } else {
        $(".range_of_recurence").removeClass("input_warning");
        return true;                                                               // all required fields are present
      }
    } else {
      $(".range_of_recurence").addClass("input_warning");
      return false;                                                              // some fields are missing
    }
  } else {
    $(".range_of_recurence").addClass("input_warning");
    return false;                                                               // some fields are missing
  }
}                                                                               // end function testStatus

/*========================================================================================================*/
function singleEvevenInputStatus(trigger) {                      // handle singel event input

  //$('.highlighter').remove();

  var start_date = $.trim($(formField().DTSTART).val());
  var end_date = $.trim($(formField().DTEND).val());
  var duration = $.trim($(formField().DURATION).val());
  var durationUnits = $.trim($(formField().DURATION_UNITS).val());

  if (trigger == "start_date") {
    if (end_date !== "") {
      end_date = new Date(end_date);
      start_date = new Date(start_date);
      if (end_date.getTime() <= start_date.getTime()) {
        end_date = $(formField().DTSTART).val();
        end_date = new Date(end_date);
        $(formField().DTEND).val(end_date);
        duration = "";
        $(formField().DURATION).val(duration);
        return false;
      } else {
        duration = moment(end_date).diff(start_date, "hours");
        duration = renderDuration(duration);
      }
    } else {
      if (duration !== "") {
        end_date = dateAdd(start_date, duration, durationUnits);
        $(formField().DTEND).val(formatDate(end_date));
      }
    }

    if (end_date == "" && duration == "") {
      return false;
    }
  }

  if (trigger == "end_date") {
    end_date = new Date(end_date);
    start_date = new Date(start_date);
    if (end_date.getTime() <= start_date.getTime()) {
      end_date = $(formField().DTSTART).val();
      end_date = new Date(end_date);
      $(formField().DTEND).val(end_date);
      duration = "";
      $(formField().DURATION).val(duration);
      return false;
    }
    duration = moment(end_date).diff(start_date, "hours");
    duration = renderDuration(duration);
  }

  if (trigger == "duration") {
    end_date = dateAdd(start_date, duration, durationUnits);
    $(formField().DTEND).val(formatDate(end_date));
  }

  var ViewstartDate = moment(start_date).format();
  var ViewendDate = moment(end_date).format();

  var eventsArray = [];
  eventsArray.push({});
  eventsArray[0].startDate = moment(start_date).format();
  eventsArray[0].eventDuration = duration;
  eventsArray[0].durationUnits = durationUnits;

  for (var i = 0; i < eventsArray.length; i++) {
    eventsArray[i].endDate = dateAdd(eventsArray[i].startDate, eventsArray[i].eventDuration, eventsArray[i].durationUnits);
    eventsArray[i].initialStartDate = eventsArray[i].startDate;
    eventsArray[i].initialEventDuration = eventsArray[i].eventDuration;
    eventsArray[i].initialDurationUnits = eventsArray[i].durationUnits;
    eventsArray[i].isDirty = false;
  }

  window.eventsArray = eventsArray;
  window.StartingDate = ViewstartDate;
  window.endingDate = ViewendDate;
  window.flag = true;
  window.zoomed = true;

  renderEvents(eventsArray, ViewstartDate, ViewendDate);

}                                                        // End of handle singel event input

/*======================================================================================*/
function renderDuration(eventDurationHours) {
  var durationUnits = $.trim($(formField().DURATION_UNITS).val());

  var duration;
  switch (durationUnits) {
    case 'day':
      duration = (eventDurationHours / 24).toFixed(2);
      break;
    case 'hour':
      duration = (eventDurationHours).toFixed(2);
      break;
    case 'minute':
      duration = Math.round(eventDurationHours * 60);
      break;
    default:
      duration = Math.round(eventDurationHours * 60);
  }

  $(formField().DURATION).val(duration);
  $("#resource_planner_event_duration").val(duration);
  return duration;
}                                                   // End of renderDuration

/*===========================================================================================================================================*/
function startDateInput() {                           // startDateInput - A date data was typed in the start date field
  var start_date = $.trim($(formField().DTSTART).val());
  if (noReccurence()) {

    if (start_date == "" || start_date == 0) {
      $.trim($(formField().DTSTART).val(""));
      $.trim($(formField().DURATION).val(""));
      $.trim($(formField().DTEND).val(""));
      $(formField().DTSTART).addClass("input_warning");
      $(formField().DURATION).addClass("input_warning");
      $(formField().DTEND).addClass("input_warning");
      $('.highlighter').remove();
      return;
    } else {
      $(formField().DTSTART).removeClass("input_warning");
      singleEvevenInputStatus("start_date");
    }
  } else {
    recurenceInputStatus($.trim($('#resource_planner_event_rrule').val()));
  }
}                                                             // end of startDateInput - A date data was typed in the start date field

/*===========================================================================================================================================*/
function endDateInput() {                          // A date data was typed in the end date field
  var start_date = $.trim($(formField().DTSTART).val());
  var duration = $.trim($(formField().DURATION).val());
  var end_date = $.trim($(formField().DTEND).val());
  if (noReccurence()) {
    start_date = new Date(start_date);
    end_date = new Date(end_date);
    if ((end_date.getTime() <= start_date.getTime()) || isNaN(end_date) || isNaN(start_date)) {
      end_date = $(formField().DTSTART).val();
      $(formField().DTEND).val(end_date);
      duration = "";
      $(formField().DURATION).val(duration);
      $(formField().DURATION).addClass("input_warning");
      $(formField().DTEND).addClass("input_warning");
      $('.highlighter').remove();
      return;
    }


    if (duration == "" && (end_date == 0 || end_date == "")) {
      $.trim($(formField().DTEND).val(""));
      $(formField().DURATION).addClass("input_warning");
      $(formField().DTEND).addClass("input_warning");
      return;
    } else {
      $(formField().DURATION).removeClass("input_warning");
      $(formField().DTEND).removeClass("input_warning");
    }
    if (start_date == "") {
      $.trim($(formField().DURATION).val(""));
      $.trim($(formField().DTEND).val(""))
      $(formField().DTSTART).addClass("input_warning");
      $(formField().DURATION).addClass("input_warning");
      $(formField().DTEND).addClass("input_warning");
      return;
    } else {
      $(formField().DTSTART).removeClass("input_warning");
    }

    if (end_date == "") {
      $.trim($(formField().DURATION).val(""));
      $.trim($(formField().DTEND).val(""))
      $(formField().DURATION).addClass("input_warning");
      $(formField().DTEND).addClass("input_warning");
      $('.highlighter').remove();
    } else {
      if (duration == "") {
        duration = moment(end_date).diff(start_date, "hours");
        $.trim($(formField().DURATION).val(duration));
        renderDuration(duration);
      }
      singleEvevenInputStatus("end_date");
    }
    //renderHighlighterBar('date');
  } else {
    recurenceInputStatus($.trim($('#resource_planner_event_rrule').val()));
  }
}                                                     // end of endDateInput - A date data was typed in the end date field

/*===========================================================================================================================================*/
function durationInput() {                            // A duration data was typed in the duration field
  var start_date = $.trim($(formField().DTSTART).val());
  var duration = $.trim($(formField().DURATION).val());
  var end_date = $.trim($(formField().DTEND).val())

  if (noReccurence()) {
    if ((duration == 0 || duration == "") && end_date == "") {
      $.trim($(formField().DURATION).val(""));
      $(formField().DURATION).addClass("input_warning");
      $(formField().DTEND).addClass("input_warning");
    } else {
      $(formField().DURATION).removeClass("input_warning");
      $(formField().DTEND).removeClass("input_warning");
    }

    if (start_date == "") {
      $.trim($(formField().DURATION).val(""));
      $.trim($(formField().DTEND).val(""))
      $(formField().DTSTART).addClass("input_warning");
      $(formField().DURATION).addClass("input_warning");
      $(formField().DTEND).addClass("input_warning");
      return;
    } else {
      $(formField().DTSTART).removeClass("input_warning");
    }

    if (duration == "") {
      $.trim($(formField().DURATION).val(""));
      $.trim($(formField().DTEND).val(""))
      $(formField().DURATION).addClass("input_warning");
      $(formField().DTEND).addClass("input_warning");
      $('.highlighter').remove();
    } else {
      singleEvevenInputStatus("duration");
    }
  } else {
    recurenceInputStatus($.trim($('#resource_planner_event_rrule').val()));
  }
}                                                         // end of durationInput - A duration data was typed in the duration field

/*===========================================================================================================================================*/
function durationUnitInput() {                            // A duration unit data was typed in the duration unit field
  if (noReccurence()) {
    var start_date = $.trim($(formField().DTSTART).val());
    var end_date = $.trim($(formField().DTEND).val())
    var duration = moment(end_date).diff(start_date, "hours");
    renderDuration(duration);
  } else {
    recurenceInputStatus($.trim($('#resource_planner_event_rrule').val()));
  }
}                                                      // end of durationUnitInput - A duration unit data was typed in the duration unit field
/*===========================================================================================================================================*/