//
// FullcalendarTimeline - Highlighter bar manipulation controls
//

// Initialise timeline manipulation controls
FullcalendarTimeline.prototype.initialiseFormFieldAribitration = function () {
  // Mechanism to pass (this) to the handlers
  var fullCalendarTimelineObject = this;

  this._formData = {};
  this._iCalData = {};

  // clear all fields
  var selected_recurrence = this.getFormField('select#resource_planner_event_rrule').val();
  this.clearFields(selected_recurrence);

  // Attach date/time selectors to the page
  $('.datetimepick').datetimepicker({
    format: 'Y-m-d H:i',
  });

  $('.datepick').datetimepicker({
    timepicker: false,
    format: 'Y-m-d',
  });

  // Attach a handler to all relevant form fields

  //
  // common fields
  //

  // title
  this.getFormField(formField().SUMMARY).on('change', function () {
    fullCalendarTimelineObject.formUpdateHandler();
    fullCalendarTimelineObject.validateFormData();
  });

  this.getFormField(formField().SUMMARY).on('input', function () {
    fullCalendarTimelineObject.formUpdateHandler();
    fullCalendarTimelineObject.validateFormData();
  });

  // description
  this.getFormField(formField().DESCRIPTION).on('change', function () {
    fullCalendarTimelineObject.formUpdateHandler();
    fullCalendarTimelineObject.validateFormData();
  });

  this.getFormField(formField().DESCRIPTION).on('input', function () {
    fullCalendarTimelineObject.formUpdateHandler();
    fullCalendarTimelineObject.validateFormData();
  });

  // start_date
  this.getFormField(formField().DTSTART).on('change', function () {
    fullCalendarTimelineObject.formUpdateHandler();
    fullCalendarTimelineObject.manageStartDateOrDurationChange();
    fullCalendarTimelineObject.validateFormData();
  });

  this.getFormField(formField().DTSTART).on('input', function () {
    fullCalendarTimelineObject.formUpdateHandler();
    fullCalendarTimelineObject.manageStartDateOrDurationChange();
    fullCalendarTimelineObject.validateFormData();
  });

  this.getFormField(formField().TZOFFSETFROM).on('change', function () {
    fullCalendarTimelineObject.formUpdateHandler();
    fullCalendarTimelineObject.manageStartDateOrDurationChange();
    fullCalendarTimelineObject.validateFormData();
  });

  this.getFormField(formField().TZOFFSETFROM).on('input', function () {
    fullCalendarTimelineObject.formUpdateHandler();
    fullCalendarTimelineObject.manageStartDateOrDurationChange();
    fullCalendarTimelineObject.validateFormData();
  });

  // duration
  this.getFormField(formField().DURATION).on('change', function () {
    fullCalendarTimelineObject.formUpdateHandler();
    fullCalendarTimelineObject.manageStartDateOrDurationChange();
    fullCalendarTimelineObject.validateFormData();
  });

  this.getFormField(formField().DURATION).on('input', function () {
    fullCalendarTimelineObject.formUpdateHandler();
    fullCalendarTimelineObject.manageStartDateOrDurationChange();
    fullCalendarTimelineObject.validateFormData();
  });

  this.getFormField(formField().DURATION_UNITS).on('change', function () {
    fullCalendarTimelineObject.formUpdateHandler();
    fullCalendarTimelineObject.manageStartDateOrDurationChange();
    fullCalendarTimelineObject.validateFormData();
  });

  // resource_planner_event_rrule (recurence rule select)
  this.getFormField('#resource_planner_event_rrule').on('change', function () {
    fullCalendarTimelineObject.formUpdateHandler();
    fullCalendarTimelineObject.handleRecurrenceSelectorChange();
    fullCalendarTimelineObject.validateFormData();
  });

  this.getFormField('#resource_planner_event_rrule').on('input', function () {
    fullCalendarTimelineObject.formUpdateHandler();
    fullCalendarTimelineObject.validateFormData();
  });

  //
  // no_repeat fields
  //

  // end_date
  this.getFormField(formField().DTEND).on('change', function () {
    fullCalendarTimelineObject.formUpdateHandler();
    fullCalendarTimelineObject.manageEndDateChange();
    fullCalendarTimelineObject.validateFormData();
  });

  this.getFormField(formField().DTEND).on('input', function () {
    fullCalendarTimelineObject.formUpdateHandler();
    fullCalendarTimelineObject.manageEndDateChange();
    fullCalendarTimelineObject.validateFormData();
  });

  this.getFormField(formField().TZOFFSETTO).on('change', function () {
    fullCalendarTimelineObject.formUpdateHandler();
    fullCalendarTimelineObject.validateFormData();
  });

  this.getFormField(formField().TZOFFSETTO).on('input', function () {
    fullCalendarTimelineObject.formUpdateHandler();
    fullCalendarTimelineObject.validateFormData();
  });

  //
  // recurence_pattern fields
  //
  this.getFormField('.day_buttons label').on('click', function () {
    var checkbox = $(this).prev('input:checkbox:first');
    if (checkbox.is(':checked')) {
      // it is currently checked, un-ckeck it
      checkbox.prop('checked', false);
      $(this).removeClass('day-button-selected');
    } else {
      // it is currently un-checked, ckeck it
      checkbox.prop('checked', true);
      $(this).addClass('day-button-selected');
    }

    fullCalendarTimelineObject.validateFormData();
  });

  this.getFormField('.monthly_day_buttons label').on('click', function () {
    var checkbox = $(this).prev('input:checkbox:first');
    if (checkbox.is(':checked')) {
      // it is currently checked, un-ckeck it
      checkbox.prop('checked', false);
      $(this).removeClass('day-button-selected');
    } else {
      // it is currently un-checked, ckeck it
      checkbox.prop('checked', true);
      $(this).addClass('day-button-selected');
    }

    fullCalendarTimelineObject.validateFormData();
  });

  // Recurrence pattern - event input fields (every n units)
  this.getFormField('.recurring_event_data input').on('change', function () {
    // check the adjacent checkbox
    $(this).parents('.row:first').find('input:first')[0].checked = true;

    fullCalendarTimelineObject.formUpdateHandler();
    fullCalendarTimelineObject.validateFormData();
  });

  this.getFormField('.recurring_event_data input').on('input', function () {
    // check the adjacent checkbox
    $(this).parents('.row:first').find('input:first')[0].checked = true;

    fullCalendarTimelineObject.formUpdateHandler();
    fullCalendarTimelineObject.validateFormData();
  });

  // Recurrence pattern - event dropdown day select fields ( e.g. 'every Nth Monday')
  this.getFormField('.recurring_event_data select').on('click', function () {
    // check the adjacent checkbox
    $(this).parents('.row:first').find('input:first')[0].checked = true;

    fullCalendarTimelineObject.formUpdateHandler();
    fullCalendarTimelineObject.validateFormData();
  });

  // Recurrence pattern - event day/date table fields (the day of the week/month)
  this.getFormField('.recurring_event_data label').on('click', function () {
    // check the adjacent checkbox
    $(this).parents('.row:first').find('input:first')[0].checked = true;

    fullCalendarTimelineObject.formUpdateHandler();
    fullCalendarTimelineObject.validateFormData();
  });

  //
  // range_of_recurence fields
  //
  this.getFormField('.range_of_recurence input').on('change', function () {
    // check the adjacent checkbox
    $(this).parents('.row:first').find('input:first')[0].checked = true;

    fullCalendarTimelineObject.formUpdateHandler();
    fullCalendarTimelineObject.validateFormData();
  });

  this.getFormField('.range_of_recurence input').on('input', function () {
    // check the adjacent checkbox
    $(this).parents('.row:first').find('input:first')[0].checked = true;

    fullCalendarTimelineObject.formUpdateHandler();
    fullCalendarTimelineObject.validateFormData();
  });

  this.getFormField('.range_of_recurence select').on('change', function () {
    // check the adjacent checkbox
    $(this).parents('.row:first').find('input:first')[0].checked = true;

    fullCalendarTimelineObject.formUpdateHandler();
    fullCalendarTimelineObject.validateFormData();
  });

  // Submit button handler
  // this.getFormField('input[type=submit]').on('click', function () {
  //   //fullCalendarTimelineObject.submitButtonHandler();
  //   fullCalendarTimelineObject.validateFormData();
  // });

  // Initialise...
  this.formUpdateHandler();
  this.validateFormData();

}

//=============================================================================
//
// Helper methods for field changes
//
//=============================================================================

//=============================================================================
// If start_date, duration or duration_units is changed, validate and update
// the DTEND field
FullcalendarTimeline.prototype.manageStartDateOrDurationChange = function () {
  var startDate = new Date(this._formData.start_date);
  var startDateIsValid = (startDate.toString() != 'Invalid Date');
  var endDate = new Date(this._formData.end_date);
  var endDateIsValid = (endDate.toString() != 'Invalid Date');
  var duration = this._formData.duration;
  var durationUnits = this._formData.duration_units;

  if (startDateIsValid) {
    if (duration.length && !isNaN(duration)) {
      // Align DTEND with DTSTART/DURATION change
      endDate = dateAdd(startDate, duration, durationUnits);
      this.getFormField(formField().DTEND).val(formatDate(endDate));
    }

    if (endDateIsValid) {

      if (endDate.getTime() <= startDate.getTime()) {
        // End Date must be >= start Date
        endDate = startDate;
        this.getFormField(formField().DURATION).val('');
        this.getFormField(formField().DTEND).val(formatDate(endDate));
      } else {
        // Update duration
        duration = endDate.diff(startDate, this._formData.duration_units);
        this.getFormField(formField().DURATION).val(duration);
      }
    }
  }

}

//=============================================================================
// If end_date changed validate and update DURATION
FullcalendarTimeline.prototype.manageEndDateChange = function () {
  var startDate = new Date(this._formData.start_date);
  var startDateIsValid = (startDate.toString() != 'Invalid Date');
  var endDate = new Date(this._formData.end_date);
  var endDateIsValid = (endDate.toString() != 'Invalid Date');
  //var duration = this._formData.duration;
  //var durationUnits = this._formData.duration_units;

  if (endDateIsValid && startDateIsValid) {
    if (endDate.getTime() <= startDate.getTime()) {
      // End Date must be >= start Date
      endDate = startDate;
      this.getFormField(formField().DURATION).val('');
      this.getFormField(formField().DTEND).val(formatDate(endDate));
    } else {
      // Update duration
      var duration = endDate.diff(startDate, this._formData.duration_units);
      this.getFormField(formField().DURATION).val(duration);
    }
  }
}

//=============================================================================

// Handle recurrence selector (resource_planner_event_rrule) change
FullcalendarTimeline.prototype.handleRecurrenceSelectorChange = function () {
  this.getFormField('.recurring_event_data').hide(); //'slow');
  this.getFormField('.range_of_recurence').hide(); //'slow');

  var selected_recurrence = this._formData.resource_planner_event_rrule;
  this.clearFields(selected_recurrence);       // clear all fields of previous screens...

  if (selected_recurrence && selected_recurrence !== 'no_repeat') {
    this.getFormField('.recurring_event_data.' + selected_recurrence).show(); //'slow');
    this.getFormField('.range_of_recurence').show(); //'slow');

    //this.getFormField(formField().DTEND)[0].readOnly = true;
    this.getFormField(formField().DTEND)[0].disabled = true;
    this.getFormField(formField().TZOFFSETTO)[0].disabled = true;
  } else {
    //this.getFormField(formField().DTEND)[0].readOnly = false;
    this.getFormField(formField().DTEND)[0].disabled = false;
    this.getFormField(formField().TZOFFSETTO)[0].disabled = false;
  }
}

//=============================================================================

// Capture form fields -> 'window' data
FullcalendarTimeline.prototype.formUpdateHandler = function () {
  this.captureFormData();
  this.updateIcalData();
  //this.prepareEventsArray();
  //this.renderEvents();
}

//=============================================================================

/**
 * Capture form fields -> formData
 */
FullcalendarTimeline.prototype.captureFormData = function () {

  this._formData.title = $.trim(this.getFormField(formField().SUMMARY).val());
  this._formData.description = $.trim(this.getFormField(formField().DESCRIPTION).val());

  this._formData.start_date = $.trim(this.getFormField(formField().DTSTART).val());
  this._formData.resource_planner_event_dtstart_timezone = $.trim(this.getFormField(formField().TZOFFSETFROM).val());

  this._formData.duration = $.trim(this.getFormField(formField().DURATION).val());
  this._formData.duration_units = $.trim(this.getFormField(formField().DURATION_UNITS).find('option:selected').val());
  if (!isNaN(this._formData.duration_units)) {
    // If val() is a number, take the text() instead
    this._formData.duration_units = $.trim(this.getFormField(formField().DURATION_UNITS).find('option:selected').text());
  }

  // recurrence rule - daily, weekly, monthly, etc.
  this._formData.resource_planner_event_rrule = $.trim(this.getFormField('#resource_planner_event_rrule').val()).toLowerCase();

  // no_repeat fields
  this._formData.end_date = $.trim(this.getFormField(formField().DTEND).val());
  this._formData.resource_planner_event_dtend_timezone = $.trim(this.getFormField(formField().TZOFFSETTO).val());

  // daily fields
  this._formData.resource_planner_event_count_every_n_days = this.getFormField('#resource_planner_event_count_every_n_days')[0].checked;
  this._formData.resource_planner_event_count_every_weekday = this.getFormField('#resource_planner_event_count_every_weekday')[0].checked;
  this._formData.resource_planner_event_count = $.trim(this.getFormField('#resource_planner_event_count').val());

  // weekly fields
  //resource_planner_event_count (See above.... In the 'weekly' case, it always refers to 'every n weeks')
  var selected_weekdays = '';
  this.getFormField('.recurring_event_data.weekly .day_buttons input[type=checkbox]').each(function (index) {
    if ($(this)[0].checked) {
      var name = $(this)[0].name;
      var day = name.substring(name.lastIndexOf('[') + 1, name.lastIndexOf(']'));
      selected_weekdays = selected_weekdays + day + '/';
    }
  });
  this._formData.selected_weekdays = selected_weekdays.substring(0, selected_weekdays.length - 1);


  // monthly fields
  this._formData.resource_planner_event_count_every_month = this.getFormField('#resource_planner_event_count_every_month')[0].checked;
  //resource_planner_event_count (See above.... In the 'monthly' case, it always refers to 'every n months')
  this._formData.resource_planner_event_bymonthday = $.trim(this.getFormField('#resource_planner_event_bymonthday').val());
  this._formData.resource_planner_event_bymonthday_day = $.trim(this.getFormField('#resource_planner_event_bymonthday_day').val());

  this._formData.resource_planner_event_count_every_month_day = this.getFormField('#resource_planner_event_count_every_month_day')[0].checked;
  var selected_days_of_month = '';
  this.getFormField('.recurring_event_data.monthly .monthly_day_buttons input[type=checkbox]').each(function (index) {
    if ($(this)[0].checked) {
      var name = $(this)[0].name;
      var date = name.substring(name.lastIndexOf('[') + 1, name.lastIndexOf(']'));
      selected_days_of_month = selected_days_of_month + date + '/';
    }
  });
  this._formData.selected_days_of_month = selected_days_of_month.substring(0, selected_days_of_month.length - 1);


  // range_of_recurence fields
  this._formData.resource_planner_event_until_no_end_date = this.getFormField('#resource_planner_event_until_no_end_date')[0].checked;
  this._formData.resource_planner_event_until_create_n_events = this.getFormField('#resource_planner_event_until_create_n_events')[0].checked;
  this._formData.resource_planner_event_until_count = $.trim(this.getFormField('#resource_planner_event_until_count').val());
  this._formData.resource_planner_event_until_repeat_until = this.getFormField('#resource_planner_event_until_repeat_until')[0].checked;
  this._formData.repeat_until = $.trim(this.getFormField('#repeat_until').val());

}

//=============================================================================

/**
 * Convert formData into iCalData
 */
FullcalendarTimeline.prototype.updateIcalData = function () {
  // This could be performed on the server-side
}

//=============================================================================
// If end_date changed validate and update DURATION

FullcalendarTimeline.prototype.validateFormData = function () {
  var startDate = new Date(this._formData.start_date);
  var startDateIsValid = (startDate.toString() != 'Invalid Date');
  var endDate = new Date(this._formData.end_date);
  var endDateIsValid = (endDate.toString() != 'Invalid Date');
  var duration = this._formData.duration;
  //var durationUnits = this._formData.duration_units;

  // Title
  if (this._formData.title) {
    this.getFormField(formField().SUMMARY).removeClass('input_warning');
  } else {
    this.getFormField(formField().SUMMARY).addClass('input_warning');
  }

  // Start/End/Duration
  if (startDateIsValid) {
    this.getFormField(formField().DTSTART).removeClass('input_warning');
  } else {
    this.getFormField(formField().DTSTART).addClass('input_warning');
  }

  if (duration && !isNaN(duration)) {
    this.getFormField(formField().DURATION).removeClass('input_warning');
  } else {
    this.getFormField(formField().DURATION).addClass('input_warning');
  }

  if (endDateIsValid) {
    this.getFormField(formField().DTEND).removeClass('input_warning');
  } else {
    this.getFormField(formField().DTEND).addClass('input_warning');
  }

  // Reccurence pattern
  switch (this._formData.resource_planner_event_rrule) {
    case 'no_repeat':
      // NOTHING TO DO
      break;

    case 'hourly':
      // NOT IMPLEMENTED
      this.getFormField(formField().DTEND).removeClass('input_warning');
      break;

    case 'daily':
      this.getFormField(formField().DTEND).removeClass('input_warning');

      var every_n_days_checkbutton = this.getFormField('.recurring_event_data.daily input#resource_planner_event_count_every_n_days')[0];
      var every_weekday_checkbutton = this.getFormField('.recurring_event_data.daily input#resource_planner_event_count_every_weekday')[0];

      if (every_n_days_checkbutton.checked) {
        var event_count_value = this.getFormField('.recurring_event_data.daily input#resource_planner_event_count').val();
        if (event_count_value.length && !isNaN(event_count_value)) {
          this.getFormField('.recurring_event_data.daily').removeClass('input_warning');
        } else {
          this.getFormField('.recurring_event_data.daily').addClass('input_warning');
        }
      } else if (every_weekday_checkbutton.checked) {
        this.getFormField('.recurring_event_data.daily').removeClass('input_warning');
      } else {
        this.getFormField('.recurring_event_data.daily').addClass('input_warning');
      }
      break;

    case 'weekly':
      this.getFormField(formField().DTEND).removeClass('input_warning');

      var every_n_weeks = this.getFormField('.recurring_event_data.weekly input');

      var every_n_weeks_value = parseInt(every_n_weeks.val());
      if (isNaN(every_n_weeks_value)) {
        this.getFormField('.recurring_event_data.weekly').addClass('input_warning');
      } else {
        var selectedWeekDays = this.getFormField('.recurring_event_data.weekly label.day-button-selected');
        if (!selectedWeekDays.length) {
          this.getFormField('.recurring_event_data.weekly').addClass('input_warning');
        } else {
          this.getFormField('.recurring_event_data.weekly').removeClass('input_warning');
        }
      }
      break;

    case 'bi_weekly':
      // NOT IMPLEMENTED
      this.getFormField(formField().DTEND).removeClass('input_warning');
      break;

    case 'monthly':
      this.getFormField(formField().DTEND).removeClass('input_warning');

      var every_n_months_checkbutton = this.getFormField('.recurring_event_data.monthly input#resource_planner_event_count_every_month')[0];
      var every_month_by_day_of_the_week = this.getFormField('.recurring_event_data.monthly input#resource_planner_event_count_every_month_by_day_of_the_week')[0];
      var every_month_day_checkbutton = this.getFormField('.recurring_event_data.monthly input#resource_planner_event_count_every_month_day')[0];

      if (every_n_months_checkbutton.checked) {
        var every_n_months_input = this.getFormField('.recurring_event_data.monthly input#resource_planner_event_count');
        var every_n_months_value = parseInt(every_n_months_input.val());
        if (isNaN(every_n_months_value)) {
          this.getFormField('.recurring_event_data.monthly').addClass('input_warning');
        } else {
          this.getFormField('.recurring_event_data.monthly').removeClass('input_warning');
        }
      } else if (every_month_by_day_of_the_week.checked) {
        this.getFormField('.recurring_event_data.monthly').removeClass('input_warning');
      } else if (every_month_day_checkbutton.checked) {
        var selectedMonthDays = this.getFormField('.recurring_event_data.monthly label.day-button-selected');
        if (!selectedMonthDays.length) {
          this.getFormField('.recurring_event_data.monthly').addClass('input_warning');
        } else {
          this.getFormField('.recurring_event_data.monthly').removeClass('input_warning');
        }
      } else {
        this.getFormField('.recurring_event_data.monthly').addClass('input_warning');
      }
      break;

    case 'annually':
      // NOT IMPLEMENTED
      this.getFormField(formField().DTEND).removeClass('input_warning');
      break;

    case 'freeform':
      // NOT IMPLEMENTED
      this.getFormField(formField().DTEND).removeClass('input_warning');
      break;
    default:
      break;
  }

  // Range of recurrence
  var until_no_end_date_checkbutton = this.getFormField('.range_of_recurence input#resource_planner_event_until_no_end_date')[0];
  var until_create_n_events_checkutton = this.getFormField('.range_of_recurence input#resource_planner_event_until_create_n_events')[0];
  var repeat_until_checkbutton = this.getFormField('.range_of_recurence input#resource_planner_event_until_repeat_until')[0];

  if (until_no_end_date_checkbutton.checked) {
    this.getFormField('.range_of_recurence').removeClass('input_warning');
  } else if (until_create_n_events_checkutton.checked) {
    var create_n_events = this.getFormField('.range_of_recurence input#resource_planner_event_until_count').val();
    var create_n_events_value = parseInt(create_n_events);
    if (isNaN(create_n_events_value)) {
      this.getFormField('.range_of_recurence').addClass('input_warning');
    } else {
      this.getFormField('.range_of_recurence').removeClass('input_warning');
    }
  } else if (repeat_until_checkbutton.checked) {
    var untilDate = this.getFormField('.range_of_recurence input#repeat_until.form-control.date-field.datepick')[0];
    var validDate = Date.parse(untilDate.value);
    if (validDate) {
      var start_date = new Date(moment(this._formData.start_date).startOf('day'));
      var newUntilDate = new Date(untilDate.value);
      if (newUntilDate < start_date) {
        untilDate.value = '';
        this.getFormField('.range_of_recurence').addClass('input_warning');
      } else {
        this.getFormField('.range_of_recurence').removeClass('input_warning');
      }
    } else {
      this.getFormField('.range_of_recurence').addClass('input_warning');
    }
  } else {
    this.getFormField('.range_of_recurence').addClass('input_warning');
  }

}

//=============================================================================
// clear all fields

FullcalendarTimeline.prototype.clearFields = function (selected_recurrence) {
  // DTSTART / DURATION / DTEND
  // $.trim(this.getFormField(formField().DTSTART).val(''));
  // $.trim(this.getFormField(formField().DURATION).val(''));
  $.trim(this.getFormField(formField().DTEND).val(''));

  // Clear DAILY Fields
  var buttonChecked = this.getFormField('.recurring_event_data.daily input#resource_planner_event_count_every_n_days');
  buttonChecked[0].checked = false;
  this.getFormField('.recurring_event_data.daily input#resource_planner_event_count').val('');
  buttonChecked = this.getFormField('.recurring_event_data.daily input#resource_planner_event_count_every_weekday');
  buttonChecked[0].checked = false;

  // Clear WEEKLY Fields
  this.getFormField('.recurring_event_data.weekly input').val('');
  this.getFormField('.recurring_event_data.weekly .day_buttons input[type=checkbox]').each(function (index) {
    $(this)[0].checked = false;
  });
  this.getFormField('.day-button-selected').removeClass('day-button-selected');

  // Clear MONTHLY Fields
  buttonChecked = this.getFormField('.recurring_event_data.monthly input#resource_planner_event_count_every_month');
  buttonChecked[0].checked = false;
  this.getFormField('.recurring_event_data.monthly input#resource_planner_event_count').val('');
  var selectedCheckedButton = this.getFormField('.recurring_event_data.monthly input#resource_planner_event_count_every_month_day');
  selectedCheckedButton[0].checked = false;

  this.getFormField('.recurring_event_data.monthly .monthly_day_buttons input[type=checkbox]').each(function (index) {
    $(this)[0].checked = false;
  });
  var selectedMonthDays = this.getFormField('.recurring_event_data.monthly label.day-button-selected');
  selectedMonthDays.removeClass('day-button-selected');

  this.getFormField('#resource_planner_event_until_no_end_date').checked = false;
  this.getFormField('#resource_planner_event_until_create_n_events').checked = false;
  this.getFormField('#resource_planner_event_until_count').val('');

  this.getFormField('#resource_planner_event_until_repeat_until').checked = false;

} // clear all fields
