//
// FullcalendarTimeline - Highlighter bar manipulation controls
//

// Initialise timeline manipulation controls
FullcalendarTimeline.prototype.initialiseHighlighterBarManipulationControls = function () {
  // Mechanism to pass (this) to the handlers
  var fullCalendarTimelineObject = this;

  // Initialise _eventsArray
  this._eventsArray = [];
  this._eventsArray.push({});

  // Other instance data
  this._startingDate = null;
  this._endingDate = null;
  this._flag = null;
  this._zoomed = null;

  /******************************************** EVENT HANDLERS ***********************************************/

  this.getFormField(formField().DTSTART).on('change', function () {
    // fullCalendarTimelineObject.renderHighlighterBar('date');
    if (fullCalendarTimelineObject._formData.resource_planner_event_rrule == 'no_repeat') {
      fullCalendarTimelineObject.singleEvevenInputStatus('start_date');
    } else {
      fullCalendarTimelineObject.recurenceInputStatus(fullCalendarTimelineObject._formData.resource_planner_event_rrule);
    }
  });

  this.getFormField(formField().DTSTART).on('input', function () {
    // fullCalendarTimelineObject.renderHighlighterBar('date');
    if (fullCalendarTimelineObject._formData.resource_planner_event_rrule == 'no_repeat') {
      fullCalendarTimelineObject.singleEvevenInputStatus('start_date');
    } else {
      fullCalendarTimelineObject.recurenceInputStatus(fullCalendarTimelineObject._formData.resource_planner_event_rrule);
    }
  });

  this.getFormField(formField().TZOFFSETFROM).on('change', function () {
    // fullCalendarTimelineObject.renderHighlighterBar('timezone');
  });

  this.getFormField(formField().TZOFFSETFROM).on('input', function () {
    // fullCalendarTimelineObject.renderHighlighterBar('timezone');
  });

  // duration
  this.getFormField(formField().DURATION).on('change', function () {
    //fullCalendarTimelineObject. fullCalendarTimelineObject.renderHighlighterBar('duration');
    if (fullCalendarTimelineObject._formData.resource_planner_event_rrule == 'no_repeat') {
      fullCalendarTimelineObject.singleEvevenInputStatus('duration');
    } else {
      fullCalendarTimelineObject.recurenceInputStatus(fullCalendarTimelineObject._formData.resource_planner_event_rrule);
    }
  });

  this.getFormField(formField().DURATION).on('input', function () {
    // fullCalendarTimelineObject.renderHighlighterBar('duration');
    if (fullCalendarTimelineObject._formData.resource_planner_event_rrule == 'no_repeat') {
      fullCalendarTimelineObject.singleEvevenInputStatus('duration');
    } else {
      fullCalendarTimelineObject.recurenceInputStatus(fullCalendarTimelineObject._formData.resource_planner_event_rrule);
    }
  });

  this.getFormField(formField().DURATION_UNITS).on('change', function () {
    // fullCalendarTimelineObject.renderHighlighterBar('duration');
    if (fullCalendarTimelineObject._formData.resource_planner_event_rrule == 'no_repeat') {
      fullCalendarTimelineObject.singleEvevenInputStatus('duration');
    } else {
      fullCalendarTimelineObject.recurenceInputStatus(fullCalendarTimelineObject._formData.resource_planner_event_rrule);
    }
  });

  // end_date
  this.getFormField(formField().DTEND).on('change', function () {
    // fullCalendarTimelineObject.renderHighlighterBar('date');
    if (fullCalendarTimelineObject._formData.resource_planner_event_rrule == 'no_repeat') {
      fullCalendarTimelineObject.singleEvevenInputStatus('end_date');
    } else {
      fullCalendarTimelineObject.recurenceInputStatus(fullCalendarTimelineObject._formData.resource_planner_event_rrule);
    }
  });

  this.getFormField(formField().DTEND).on('input', function () {
    // fullCalendarTimelineObject.renderHighlighterBar('date');
    if (fullCalendarTimelineObject._formData.resource_planner_event_rrule == 'no_repeat') {
      fullCalendarTimelineObject.singleEvevenInputStatus('end_date');
    } else {
      fullCalendarTimelineObject.recurenceInputStatus(fullCalendarTimelineObject._formData.resource_planner_event_rrule);
    }
  });

  this.getFormField(formField().TZOFFSETTO).on('change', function () {
    // fullCalendarTimelineObject.renderHighlighterBar('timezone');
  });

  this.getFormField(formField().TZOFFSETTO).on('input', function () {
    // fullCalendarTimelineObject.renderHighlighterBar('timezone');
  });

  // resource_planner_event_rrule (recurence rule select)
  this.getFormField('#resource_planner_event_rrule').on('change', function () {
    // Remove existing 'highlighter' bars
    if (fullCalendarTimelineObject._timelineViewWrapper.find('.highlighter').length != 0) {
      fullCalendarTimelineObject._timelineViewWrapper.find('.highlighter').remove();
    }

    fullCalendarTimelineObject.recurenceInputStatus($.trim(fullCalendarTimelineObject.getFormField('#resource_planner_event_rrule').val()).toLowerCase());
  });

  this.getFormField('#resource_planner_event_rrule').on('input', function () {
    fullCalendarTimelineObject.recurenceInputStatus($.trim(fullCalendarTimelineObject.getFormField('#resource_planner_event_rrule').val()).toLowerCase());
  });

  this.getFormField('.recurring_event_data.daily input').on('input', function () {
    fullCalendarTimelineObject.recurenceInputStatus($.trim(fullCalendarTimelineObject.getFormField('#resource_planner_event_rrule').val()).toLowerCase());
  });

  this.getFormField('.recurring_event_data.weekly input').on('input', function () {       // every_n_week(s) field was typed
    fullCalendarTimelineObject.recurenceInputStatus($.trim(fullCalendarTimelineObject.getFormField('#resource_planner_event_rrule').val()).toLowerCase());
  });

  this.getFormField(".day_buttons label").on("click", function () {         // one of the days of the week was selected
    fullCalendarTimelineObject.recurenceInputStatus($.trim(fullCalendarTimelineObject.getFormField('#resource_planner_event_rrule').val()).toLowerCase());
  });

  this.getFormField('.recurring_event_data.monthly input').on('input', function () {               // every_n_week(s) field was typed
    fullCalendarTimelineObject.recurenceInputStatus($.trim(fullCalendarTimelineObject.getFormField('#resource_planner_event_rrule').val()).toLowerCase());
  });

  this.getFormField('#resource_planner_event_bymonthday').on('change', function () {
    fullCalendarTimelineObject.recurenceInputStatus($.trim(fullCalendarTimelineObject.getFormField('#resource_planner_event_rrule').val()).toLowerCase());
  });

  this.getFormField('#resource_planner_event_bymonthday_day').on('change', function () {
    fullCalendarTimelineObject.recurenceInputStatus($.trim(fullCalendarTimelineObject.getFormField('#resource_planner_event_rrule').val()).toLowerCase());
  });

  this.getFormField(".monthly_day_buttons label").on("click", function () {
    fullCalendarTimelineObject.recurenceInputStatus($.trim(fullCalendarTimelineObject.getFormField('#resource_planner_event_rrule').val()).toLowerCase());
  });

  this.getFormField('#resource_planner_event_bymonthday_day').on('change', function () {
    fullCalendarTimelineObject.recurenceInputStatus($.trim(fullCalendarTimelineObject.getFormField('#resource_planner_event_rrule').val()).toLowerCase());
  });

  this.getFormField('.range_of_recurence input').on('input', function () {
    fullCalendarTimelineObject.recurenceInputStatus($.trim(fullCalendarTimelineObject.getFormField('#resource_planner_event_rrule').val()).toLowerCase());
  });

  this.getFormField('#repeat_until').on('change', function () {
    fullCalendarTimelineObject.recurenceInputStatus($.trim(fullCalendarTimelineObject.getFormField('#resource_planner_event_rrule').val()).toLowerCase());
  });

}

//=============================================================================
// Return highlighter object
//=============================================================================
FullcalendarTimeline.prototype.getHighlighterBar = function () {
  return this._timelineViewWrapper.find('#highlighter');
}


//
// Common/Helper functions
//

FullcalendarTimeline.prototype.getEventWindowHeight = function () {
  var view = this._fullcalendarObject.view;
  return view.timeAxisTbody.clientHeight;
}

FullcalendarTimeline.prototype.getEventWindowWidth = function () {
  var view = this._fullcalendarObject.view;
  return view.timeAxisTbody.clientWidth;
}

FullcalendarTimeline.prototype.getEventWindowHours = function () {
  var view = this._fullcalendarObject.view;
  var start = view.currentStart;
  var end = view.currentEnd;
  var days = end.diff(start, 'days');
  var eventWindowHours = 24 * days;
  return eventWindowHours;
}

//=============================================================================
// Calculates the UTC Offsets
//=============================================================================
FullcalendarTimeline.prototype.tzOffset = function () {
  var startTZ = this._formData.resource_planner_event_dtstart_timezone;
  var startZone = moment;
  // Set the Timezone
  startZone.tz.setDefault(startTZ)();
  // Total UTC offset in milliseconds
  var utcOffset = startZone().utcOffset() * 60000;

  return utcOffset;
}

//=============================================================================
FullcalendarTimeline.prototype.getEventDurationHours = function () {
  var view = this._fullcalendarObject.view;

  var viewDuration = view.currentEnd.diff(view.currentStart, 'hours');
  var eventDurationHours = viewDuration * this.getHighlighterBar().width() / this.getEventWindowWidth();

  return eventDurationHours;
}

//=============================================================================
FullcalendarTimeline.prototype.setHighlighterBarWidth = function (duration, durationUnits) {
  var view = this._fullcalendarObject.view;

  var eventDurationHours;
  switch (durationUnits) {
    case 'day':
      eventDurationHours = duration * 24.0;
      break;
    case 'hour':
      eventDurationHours = duration;
      break;
    case 'minute':
      eventDurationHours = duration / 60.0;
      break;
    default:
      eventDurationHours = duration / 60.0;
  }

  var viewDuration = view.currentEnd.diff(view.currentStart, 'hours');
  var width = this.getEventWindowWidth() * eventDurationHours / viewDuration;

  this.getHighlighterBar().css('width', width);

  return width;
}

//=============================================================================
//Function is triggered by either DRAG or RESIZE events
FullcalendarTimeline.prototype.onHighlighterBarUpdate = function (event, ui, obj) {
  var isRTL = (this._fullcalendarObject.getOption('dir') == 'rtl');
  var view = this._fullcalendarObject.view;
  var viewStartDate = new Date(view.currentStart);

  var eventStartTimeHours;
  var eventEndTimeHours;
  var viewDuration = view.currentEnd.diff(view.currentStart, 'hours');
  var eventDurationHours = viewDuration * obj.width() / this.getEventWindowWidth();

  if (isRTL) {
    eventEndTimeHours = this.getEventWindowHours() - (this.getEventWindowHours() * ui.position.left / this.getEventWindowWidth());
    eventStartTimeHours = eventEndTimeHours - eventDurationHours;
  } else {
    eventStartTimeHours = this.getEventWindowHours() * ui.position.left / this.getEventWindowWidth();
  }

  // Date object methods
  // setDate()	Sets the day of the month of a date object
  // setFullYear()	Sets the year of a date object
  // setHours()	Sets the hour of a date object
  // setMilliseconds()	Sets the milliseconds of a date object
  // setMinutes()	Set the minutes of a date object
  // setMonth()	Sets the month of a date object

  var startDate = dateAdd(viewStartDate, parseInt(eventStartTimeHours / 24), 'day');
  startDate.setHours(Math.floor(eventStartTimeHours % 24));
  startDate.setMinutes(60 * (eventStartTimeHours % 1).toFixed(10));

  var id = obj.attr('id');
  if (id == 'highlighter') {
    // The old highlighter bar
    //this.getFormField(formField().DTSTART).val(formatDate(startDate));
    //this.renderDurationField();
    //renderEndDateField();
  } else {
    var eventIndex = id.split('-')[1];
    var duration = getDurationInUnits(eventDurationHours, this._eventsArray[eventIndex].durationUnits);
    this._eventsArray[eventIndex].startDate = moment(startDate).format();
    this._eventsArray[eventIndex].eventDuration = duration.toString();
    this._eventsArray[eventIndex].endDate = dateAdd(this._eventsArray[eventIndex].startDate, this._eventsArray[eventIndex].eventDuration, this._eventsArray[eventIndex].durationUnits);
    this._eventsArray[eventIndex].isDirty = true;

    if (this.noReccurence()) {
      $.trim(this.getFormField(formField().DURATION).val(duration));
      var end_date = dateAdd(startDate, duration, this._eventsArray[eventIndex].durationUnits);
      this.getFormField(formField().DTEND).val(formatDate(end_date));
      this.getFormField(formField().DTSTART).val(formatDate(startDate));
    }
  }
}
/*========================================================================================================*/

FullcalendarTimeline.prototype.noReccurence = function () {
  if ($.trim(this.getFormField('#resource_planner_event_rrule').val()) == 'no_repeat') {
    return true;                      // all required fields are present
  }
}

//=============================================================================
//function triggered when '.date-field' or DURATION fields changed
FullcalendarTimeline.prototype.renderHighlighterBar = function (trigger) {
  var fullCalendarTimelineObject = this;

  if (this.getHighlighterBar().length == 0) {
    this._timelineViewWrapper.find('#fullcalendar_scheduler tbody.fc-body td.fc-time-area div.fc-scroller div.fc-scroller-canvas').prepend($('<div id="highlighter" draggable="true"></div>'));
  }

  this.tzOffset();

  this.getHighlighterBar().on('drag', function (event, ui) {
    fullCalendarTimelineObject.onHighlighterBarUpdate(event, ui, $(this));
  });

  this.getHighlighterBar().on('resize', function (event, ui) {
    fullCalendarTimelineObject.onHighlighterBarUpdate(event, ui, $(this));
  });

  var start_date = $.trim(this.getFormField(formField().DTSTART).val());
  var end_date = $.trim(this.getFormField(formField().DTEND).val());
  var duration = $.trim(this.getFormField(formField().DURATION).val());
  var durationUnits = this._formData.duration_units;

  var isRTL = (this._fullcalendarObject.getOption('dir') == 'rtl');
  var view = this._fullcalendarObject.view;

  var viewStartDate = new Date(view.currentStart);
  var viewEndDate = new Date(view.currentEnd);

  var viewStartTime = viewStartDate.getTime();
  var viewEndTime = viewEndDate.getTime();
  var viewDuration = viewEndTime - viewStartTime;

  if ((start_date.length && end_date.length) || (duration.length) || (start_date == '')) {
    var startDate = new Date(start_date);
    var endDate = new Date(end_date);

    var width;
    // End Date must be >= start Date
    if ((endDate.getTime() <= startDate.getTime()) || isNaN(endDate) || isNaN(startDate)) {
      end_date = this.getFormField(formField().DTSTART).val();
      endDate = new Date(end_date);
      this.getFormField(formField().DTEND).val(end_date);
      duration = '';
      this.getFormField(formField().DURATION).val(duration);
      width = 0;
      this.getHighlighterBar().css('width', width)
    }

    switch (trigger) {
      case 'duration':
        if (duration.length) {
          width = this.setHighlighterBarWidth(duration, durationUnits)

          if (isRTL) {
            this.getHighlighterBar().css('left', this.getEventWindowWidth() - ((((startDate.getTime() + this.tzOffset()) - viewStartTime) / viewDuration) * this.getEventWindowWidth()) - width);
          } else {
            this.getHighlighterBar().css('left', (((startDate.getTime() - viewStartTime) / viewDuration) * view.timeAxisTbody.clientWidth));
            //this.getHighlighterBar().css('left', (((startDate.getTime() + this.tzOffset()) - viewStartTime) / viewDuration) * view.timeBodyScroller.canvas.width);
          }
        }
        break;

      case 'date':
      default:
        if (end_date.length) {
          if (isRTL) {
            this.getHighlighterBar().css('left', (view.timeAxisTbody.clientWidth - ((((endDate.getTime() - viewStartDate.getTime()) + this.tzOffset()) / viewDuration) * view.timeAxisTbody.clientWidth)));
            //this.getHighlighterBar().css('left', (view.timeBodyScroller.canvas.width - ((((endDate.getTime() - viewStartDate.getTime()) + this.tzOffset()) / viewDuration) * view.timeBodyScroller.canvas.width)));
          } else {
            this.getHighlighterBar().css('left', (((startDate.getTime() - viewStartTime) / viewDuration) * view.timeAxisTbody.clientWidth));
            //this.getHighlighterBar().css('left', (((startDate.getTime() + this.tzOffset()) - viewStartTime) / viewDuration) * view.timeBodyScroller.canvas.width);
          }
          this.setHighlighterBarWidth(endDate.diff(startDate, durationUnits), durationUnits);
        }
        break;
    }

    this.getHighlighterBar().height(this.getEventWindowHeight());
    this.getHighlighterBar().draggable({ axis: 'x' });
    this.getHighlighterBar().resizable({ handles: 'e, w' });
    this.getHighlighterBar().css('visibility', 'visible'); // TODO: Move this inside the if block

    if ((this.getHighlighterBar()[0].clientWidth > 0 && (endDate.getTime() > startDate.getTime())) || (this.getHighlighterBar()[0].clientWidth > 0 && isNaN(endDate.getTime()))) {
      this.renderDurationField();
    }
  }
}

/*========================================================================================================*/
FullcalendarTimeline.prototype.singleEvevenInputStatus = function (trigger) {                      // handle singel event input

  //this.getFormField('.highlighter').remove();

  var start_date = $.trim(this.getFormField(formField().DTSTART).val());
  var end_date = $.trim(this.getFormField(formField().DTEND).val());
  var duration = $.trim(this.getFormField(formField().DURATION).val());
  var durationUnits = this._formData.duration_units;

  if (trigger == 'start_date') {
    if (end_date !== '') {
      end_date = new Date(end_date);
      start_date = new Date(start_date);
      if (end_date.getTime() <= start_date.getTime()) {
        end_date = this.getFormField(formField().DTSTART).val();
        end_date = new Date(end_date);
        this.getFormField(formField().DTEND).val(end_date);
        duration = '';
        this.getFormField(formField().DURATION).val(duration);
        return false;
      } else {
        duration = moment(end_date).diff(start_date, 'hours');
        duration = this.renderDuration(duration);
      }
    } else {
      if (duration !== '') {
        end_date = dateAdd(start_date, duration, durationUnits);
        this.getFormField(formField().DTEND).val(formatDate(end_date));
      }
    }

    if (end_date == '' && duration == '') {
      return false;
    }
  }

  if (trigger == 'end_date') {
    end_date = new Date(end_date);
    start_date = new Date(start_date);
    if (end_date.getTime() <= start_date.getTime()) {
      end_date = this.getFormField(formField().DTSTART).val();
      end_date = new Date(end_date);
      this.getFormField(formField().DTEND).val(end_date);
      duration = '';
      this.getFormField(formField().DURATION).val(duration);
      return false;
    }
    duration = moment(end_date).diff(start_date, 'hours');
    duration = this.renderDuration(duration);
  }

  if (trigger == 'duration') {
    if (start_date !== '' && duration !== '') {
      end_date = dateAdd(start_date, duration, durationUnits);
      this.getFormField(formField().DTEND).val(formatDate(end_date));
    } else {
      return false;
    }
  }

  var viewStartDate = moment(start_date).format();
  var viewEndDate = moment(end_date).format();

  var eventsArray = [];
  eventsArray.push({});
  eventsArray[0].startDate = moment(start_date).format();
  eventsArray[0].eventDuration = duration;
  eventsArray[0].durationUnits = durationUnits;

  for (var i = 0; i < eventsArray.length; i++) {
    eventsArray[i].endDate = dateAdd(eventsArray[i].startDate, eventsArray[i].eventDuration, eventsArray[i].durationUnits);
    eventsArray[i].initialStartDate = eventsArray[i].startDate;
    eventsArray[i].initialEventDuration = eventsArray[i].eventDuration;
    eventsArray[i].initialDurationUnits = eventsArray[i].durationUnits;
    eventsArray[i].isDirty = false;
  }

  this._eventsArray = eventsArray;
  this._startingDate = viewStartDate;
  this._endingDate = viewEndDate;
  this._flag = true;
  this._zoomed = true;

  this.renderEvents(eventsArray, viewStartDate, viewEndDate);

}                                                        // End of handle singel event input

/*========================================================================================================*/
/*  check presence of all required fields for recurence                                                  */
/*________________________________________________________________________________________________________*/
FullcalendarTimeline.prototype.recurenceInputStatus = function (recurencePattern) {

  this.getFormField('.highlighter').remove();                             // clear previous rendered evenets

  var start_date = $.trim(this.getFormField(formField().DTSTART).val());
  var duration = $.trim(this.getFormField(formField().DURATION).val());
  var durationUnits = this._formData.duration_units;

  this.testStatus(recurencePattern);

  if (start_date == '' || duration == '' || durationUnits == '') {
    return false;                                                         // some fields are missing
  }

  var recurenceObject = {        // This object will be passed over to the prepareEvents Function
    startDate: start_date,
    eventDuration: duration,
    durationUnits: durationUnits,
    howOften: '',                 // Every how many days/weeks/months ?
    when: [],                     // Array icluding the week days, or month days (02, 07, 15,...)
    nrOfEvents: '',               // Number of events
    endDate: '',
  }

  var i;
  var values;

  // Check the presence of the recurence pattern section
  switch (recurencePattern) {
    case 'daily':                                                         // check the presence of the DAILY recurence pattern fields
      var buttonChecked = this.getFormField('.recurring_event_data.daily input#resource_planner_event_count_every_n_days');
      if (buttonChecked[0].checked) {        // is every_n_days button is checked...
        var nrDays = this.getFormField('.recurring_event_data.daily input#resource_planner_event_count').val(); // every_n_days button is checked
        values = parseInt(nrDays);
        if (isNaN(values)) {
          return false;                                              // 'n' of every 'n' days is missing
        } else {
          recurenceObject.howOften = values;
          break;                                                       // 'n' of every 'n' days is present
        }
      } else {                                                           // every_n_days button is not checked
        buttonChecked = this.getFormField('.recurring_event_data.daily input#resource_planner_event_count_every_weekday');
        if (buttonChecked[0].checked) {                                 // is every_weekday butoon is checked
          recurenceObject.howOften = 1;
          break;                                                         // every_weekday butoon is checked
        } else {
          return false;                                                  // every_weekday butoon is not checked
        }
      }
    case 'weekly':                                                        // check the presence of the WEEKLY recurence pattern fields
      var every_n_weeks = this.getFormField('.recurring_event_data.weekly input').val();            // is 'n' for every_n_weeks field was typed ?
      values = parseInt(every_n_weeks);
      if (isNaN(values)) {
        return false;                                                 // if 'n' not a number, e.g. n = '', then stop checking further fields
      } else {
        recurenceObject.howOften = values;
        var selectedWeekDays = this.getFormField('.recurring_event_data.weekly label.day-button-selected');
        if (!selectedWeekDays.length) {                                 // if length = 0 (no day of week was selected)
          return false;                                               // some fields are missing
        } else {
          for (i = 0; i < selectedWeekDays.length; i++) {
            recurenceObject.when[i] = selectedWeekDays[i].innerHTML;
          }
          break;
        }

        //break;
      }
    //}
    case 'monthly':                                                   // check the presence of the MONTHLY recurence pattern fields
      buttonChecked = this.getFormField('.recurring_event_data.monthly input#resource_planner_event_count_every_month');
      if (buttonChecked[0].checked) {                             // every_n_month button was checked
        var every_n_months = this.getFormField('.recurring_event_data.monthly input#resource_planner_event_count').val();
        values = parseInt(every_n_months);
        if (isNaN(values)) {
          return false;                                         // if 'n' not a number, e.g. n = '', then stop checking further fields
        } else {
          recurenceObject.howOften = values;
          var cycle = this.getFormField('.recurring_event_data.monthly select#resource_planner_event_bymonthday').val();
          var whichDay = this.getFormField('.recurring_event_data.monthly select#resource_planner_event_bymonthday_day').val();
          recurenceObject.when[0] = cycle;
          recurenceObject.when[1] = whichDay;
          break;
        }
      } else {
        var selectedCheckedButton = this.getFormField('.recurring_event_data.monthly input#resource_planner_event_count_every_month_day');   // is the day_of_month button checked ?
        if (!selectedCheckedButton[0].checked) {                                        // if length = 0 (no day of week was selected)
          return false;                                                                // some fields are missing
        } else {
          var selectedMonthDays = this.getFormField('.recurring_event_data.monthly label.day-button-selected');
          if (!selectedMonthDays.length) {                                              // if length !== 0 (day of week was selected)
            return false;                                                               // some fields are missing
          } else {
            for (i = 0; i < selectedMonthDays.length; i++) {
              recurenceObject.when[i] = selectedMonthDays[i].innerHTML;
            }
            break;
          }
        }
      }
  }

  // checking the presence of the range_of_recurence fields section
  var selectedButton = this.getFormField('.range_of_recurence input#resource_planner_event_until_no_end_date');
  if (selectedButton[0].checked) {
    var datum = moment(start_date);
    var endDatum = datum.add(6, 'months');
    recurenceObject.endDate = endDatum.format();
    this.prepareEvents(recurenceObject, recurencePattern);
    return true;                                                // all required fields are present
  }

  selectedButton = this.getFormField('.range_of_recurence input#resource_planner_event_until_create_n_events');        // was create_n_events button checked ?
  if (selectedButton[0].checked) {                                                                      // YES, create_n_events button was checked
    var create_n_events = this.getFormField('.range_of_recurence input#resource_planner_event_until_count').val();     // check presence of 'n' events number
    values = parseInt(create_n_events);
    if (isNaN(values)) {                                                                                // is 'n' number of events present ?
      return false;                                                               // NO, number of 'n' is not present, stop checking
    } else {
      recurenceObject.nrOfEvents = values;                                        // Number of events
      this.prepareEvents(recurenceObject, recurencePattern);
      return true;                                                                 // all required fields are present
    }
  }

  selectedButton = this.getFormField('.range_of_recurence input#resource_planner_event_until_repeat_until');          // was repeat button until checked ?
  if (selectedButton[0].checked) {                                                                   // Yes, check presence of the until date
    var untilDate = this.getFormField('.range_of_recurence input#repeat_until.form-control.date-field.datepick');
    var validDate = Date.parse(untilDate[0].value)
    if (validDate) {
      var begin_date = new Date(moment(recurenceObject.startDate).startOf('day'));
      var newUntilDate = new Date(untilDate[0].value);
      if (newUntilDate < begin_date) {
        untilDate[0].value = '';
        return false;
      } else {
        recurenceObject.endDate = untilDate[0].value;
        this.prepareEvents(recurenceObject, recurencePattern);
        return true;                                                               // all required fields are present
      }
    } else {
      return false;                                                              // some fields are missing
    }
  } else {
    return false;                                                                 // some fields are missing
  }
}
// end function recurenceInputStatus

/*========================================================================================================*/
// TODO: This method is redundant
FullcalendarTimeline.prototype.testStatus = function (recurencePattern) {

  var start_date = $.trim(this.getFormField(formField().DTSTART).val());
  var duration = $.trim(this.getFormField(formField().DURATION).val());
  var durationUnits = this._formData.duration_units;

  // This object will be passed over to the recurence event render Function
  // TODO: This object is redundant because it has local scope
  var recurenceObject = {
    startDate: start_date,
    eventDuration: duration,
    durationUnits: durationUnits,
    howOften: "",                 // Every how many days/weeks/months ?
    when: [],                     // Array icluding the week days, or month days (02, 07, 15,...)
    nrOfEvents: "",               // Number of events
    endDate: "",
  };

  var values;

  // Check the presence of the recurence pattern section
  switch (recurencePattern) {
    case "daily":                                                         // check the presence of the DAILY recurence pattern fields
      break;

    case "weekly":                                                        // check the presence of the WEEKLY recurence pattern fields
      var every_n_weeks = $('.recurring_event_data.weekly input').val();            // is 'n' for every_n_weeks field was typed ?
      values = parseInt(every_n_weeks);
      if (isNaN(values)) {
      } else {
        recurenceObject.howOften = values;
      }
      break;

    case "monthly":                                                   // check the presence of the MONTHLY recurence pattern fields
      break;
  }

  // checking the presence of the range_of_recurence fields section
  var selectedButton = $('.range_of_recurence input#resource_planner_event_until_no_end_date');
  if (selectedButton[0].checked) {
    // all required fields are present
    return true;
  }

  selectedButton = $('.range_of_recurence input#resource_planner_event_until_create_n_events');        // was create_n_events button checked ?
  if (selectedButton[0].checked) {                                                                      // YES, create_n_events button was checked
    var create_n_events = $('.range_of_recurence input#resource_planner_event_until_count').val();     // check presence of 'n' events number
    values = parseInt(create_n_events);
    if (isNaN(values)) {                                                                                // is 'n' number of events present ?
    } else {
      // all required fields are present
      return true;
    }
  }

  selectedButton = $('.range_of_recurence input#resource_planner_event_until_repeat_until');          // was repeat button until checked ?
  if (selectedButton[0].checked) {                                                                   // Yes, check presence of the until date
    var untilDate = $('.range_of_recurence input#repeat_until.form-control.date-field.datepick');
    var validDate = Date.parse(untilDate[0].value)
    if (validDate) {
      var begin_date = new Date(moment(recurenceObject.startDate).startOf('day'));
      var newUntilDate = new Date(untilDate[0].value);
      if (newUntilDate < begin_date) {
        untilDate[0].value = "";
        // some fields are missing
        return false;
      } else {
        // all required fields are present
        return true;
      }
    } else {
      // some fields are missing
      return false;
    }
  } else {
    // some fields are missing
    return false;
  }
} // end function testStatus

//=============================================================================
FullcalendarTimeline.prototype.renderDurationField = function () {
  var eventDurationHours = this.getEventDurationHours();
  var durationUnits = this._formData.duration_units;

  var duration;
  switch (durationUnits) {
    case 'day':
      duration = (eventDurationHours / 24).toFixed(2);
      break;
    case 'hour':
      duration = (eventDurationHours).toFixed(2);
      break;
    case 'minute':
      duration = Math.round(eventDurationHours * 60);
      break;
    case 'second':
      duration = Math.round(eventDurationHours * 60 * 60);
      break;
    default:
      duration = Math.round(eventDurationHours * 60);
      break;
  }

  this.getFormField(formField().DURATION).val(duration);
  // TODO: Is this line required
  // this.getFormField('#resource_planner_event_duration').val(duration);
  // TODO: Is this line required
}

//=============================================================================
FullcalendarTimeline.prototype.renderDuration = function (eventDurationHours) {
  var durationUnits = this._formData.duration_units;

  var duration;
  switch (durationUnits) {
    case 'day':
      duration = (eventDurationHours / 24).toFixed(2);
      break;
    case 'hour':
      duration = (eventDurationHours).toFixed(2);
      break;
    case 'minute':
      duration = Math.round(eventDurationHours * 60);
      break;
    case 'second':
      duration = Math.round(eventDurationHours * 60 * 60);
      break;
    default:
      duration = Math.round(eventDurationHours * 60);
      break;
  }

  this.getFormField(formField().DURATION).val(duration);
  // TODO: Is this line required
  // this.getFormField("#resource_planner_event_duration").val(duration);
  // TODO: Is this line required

  return duration;
} // End of renderDuration

//=============================================================================
// Function to prepare events for rendering
//=============================================================================
FullcalendarTimeline.prototype.prepareEvents = function (recurenceObject, recurencePattern) {
  var end_date;
  var start_date;
  var selectedWeekDayNumber;
  var startWeekDayNumber;
  var i;
  var now;
  var end;
  var duration;
  var eventsArray = [];
  var nrOfOccurences;
  var found = false;

  viewStartDate = recurenceObject.startDate;
  viewEndDate = recurenceObject.endDate;

  // SWITCH FOR SINGLE EVENT, DAILY, WEEKLY or MONTHLY
  switch (recurencePattern) {
    //               ***** D A I L Y *****
    case 'daily':
      if (recurenceObject.nrOfEvents) {
        // number of selected days is greater than number of events
        for (var i = 0; i < recurenceObject.nrOfEvents; i++) {
          eventsArray.push({});
        }

        for (var i = 0; i < recurenceObject.nrOfEvents; i++) {
          if (i == 0) {
            eventsArray[i].startDate = recurenceObject.startDate;
            eventsArray[i].eventDuration = recurenceObject.eventDuration;
            eventsArray[i].durationUnits = recurenceObject.durationUnits;
            viewEndDate = eventsArray[i].startDate;
          } else {
            start_date = getDailyEventStartDate(eventsArray[i - 1].startDate, recurenceObject.howOften);
            eventsArray[i].startDate = start_date;
            eventsArray[i].eventDuration = recurenceObject.eventDuration;
            eventsArray[i].durationUnits = recurenceObject.durationUnits;
            viewEndDate = eventsArray[i].startDate;
          }
        }

      } else {
        now = moment(recurenceObject.startDate);
        end = moment(recurenceObject.endDate);
        nrOfOccurences = Math.round((moment(end).diff(now, 'days') + 2) / recurenceObject.howOften);

        for (var i = 0; i < nrOfOccurences; i++) {                             // number of selected days is greater than number of events
          eventsArray.push({});
        }

        for (var i = 0; i < nrOfOccurences; i++) {
          if (i == 0) {
            eventsArray[i].startDate = recurenceObject.startDate;
            eventsArray[i].eventDuration = recurenceObject.eventDuration;
            eventsArray[i].durationUnits = recurenceObject.durationUnits;
          } else {
            start_date = getDailyEventStartDate(eventsArray[i - 1].startDate, recurenceObject.howOften);
            eventsArray[i].startDate = start_date;
            eventsArray[i].eventDuration = recurenceObject.eventDuration;
            eventsArray[i].durationUnits = recurenceObject.durationUnits;
          }
        }
      }

      viewStartDate = eventsArray[0].startDate;
      viewEndDate = eventsArray[eventsArray.length - 1].startDate;

      for (var i = 0; i < eventsArray.length; i++) {
        eventsArray[i].endDate = dateAdd(eventsArray[i].startDate, eventsArray[i].eventDuration, eventsArray[i].durationUnits);
        eventsArray[i].initialStartDate = eventsArray[i].startDate;
        eventsArray[i].initialEventDuration = eventsArray[i].eventDuration;
        eventsArray[i].initialDurationUnits = eventsArray[i].durationUnits;
        eventsArray[i].isDirty = false;
      }

      this._eventsArray = eventsArray;
      this._startingDate = viewStartDate;
      this._endingDate = viewEndDate;
      this._flag = true;
      this._zoomed = false;

      this.updateTimelineDuration(viewStartDate, viewEndDate);
      //renderEvents(eventsArray, viewStartDate, viewEndDate);

      break;

    //               ***** W  E  E  K  L  Y *****
    case 'weekly':
      var weekDaysNumberArray = [];
      var selectedDayOfWeekNumber;
      var numberOfDays;
      var StartDayOfWeek = moment(recurenceObject.startDate);
      var StartDayOfWeekNumber = StartDayOfWeek.day();

      for (var i = 0; i < recurenceObject.when.length; i++) {     // create a new array to hold week days number
        weekDaysNumberArray.push({});
      }

      for (var i = 0; i < recurenceObject.when.length; i++) {     // update the array with the selectedweekdays to hold day numbers
        selectedDayOfWeekNumber = moment().day(recurenceObject.when[i]);
        weekDaysNumberArray[i] = selectedDayOfWeekNumber.day();
      }

      for (var i = 0; i < weekDaysNumberArray.length; i++) {      // find the start day dependent on the startDate (selected in the menu)
        if (StartDayOfWeekNumber <= weekDaysNumberArray[i]) {
          numberOfDays = weekDaysNumberArray[i] - StartDayOfWeekNumber;
          start_date = moment(recurenceObject.startDate).add(numberOfDays, 'days');
          var index = i;                                      // index of the found next day...
          found = true;
          break;
        }
      }

      if (!found) {
        for (var i = 0; i < weekDaysNumberArray.length; i++) {
          if (StartDayOfWeekNumber >= weekDaysNumberArray[i]) {
            numberOfDays = (7 - StartDayOfWeekNumber) + 1;
            start_date = moment(recurenceObject.startDate).add(numberOfDays, 'days');
            break;
          }
        }
      }

      var partOfArray = [];
      if (found) {
        partOfArray = weekDaysNumberArray.slice(index);
        for (var i = 0; i < partOfArray.length; i++) {
          weekDaysNumberArray.pop();
        }
        weekDaysNumberArray = partOfArray.concat(weekDaysNumberArray);
      }

      var StartDayOfWeek = moment(start_date);

      if (recurenceObject.nrOfEvents == '') {
        var totalDayOfAppearance = 0;
        var dayNumberOfAppearances = 0;
        for (var i = 0; i < weekDaysNumberArray.length; i++) {
          dayNumberOfAppearances = countSelectedWeekdayAppearance(start_date, recurenceObject.endDate, weekDaysNumberArray[i]);
          dayNumberOfAppearances = Math.ceil(dayNumberOfAppearances / recurenceObject.howOften);
          totalDayOfAppearance = totalDayOfAppearance + dayNumberOfAppearances;
          dayNumberOfAppearances = 0;
        }

        for (i = 0; i < totalDayOfAppearance; i++) {                   // number of selected days is greater than number of events
          eventsArray.push({});
        }
      } else {
        for (var i = 0; i < recurenceObject.nrOfEvents; i++) {                   // number of selected days is greater than number of events
          eventsArray.push({});
        }
      }

      if (recurenceObject.nrOfEvents) {    // Number of events greater than zero                                                          // number of events is selected

        // calculate the end_date
        var nrOfWeeks = (recurenceObject.nrOfEvents * recurenceObject.howOften) + recurenceObject.howOften; // number of weeks until the end date
        end_date = moment(start_date);
        var viewEndDate = moment(end_date).add(nrOfWeeks, 'weeks');
        var viewStartDate = moment(start_date);


        var j;
        for (var i = 0; i < recurenceObject.nrOfEvents; i++) {
          startWeekDayNumber = moment(start_date).day();         // get the weekday number of the start date, e.g. sunday=0, monday=1,... here we get the startDate day number
          var index = i % weekDaysNumberArray.length;

          if (index == 0 && i != 0) {
            numberOfDays = 7 * recurenceObject.howOften;
            start_date = moment(start_date).add(numberOfDays, 'days');
          }

          eventsArray[i].startDate = getWeeklyEventStartDate(weekDaysNumberArray[index], startWeekDayNumber, start_date);
          eventsArray[i].eventDuration = recurenceObject.eventDuration;
          eventsArray[i].durationUnits = recurenceObject.durationUnits;
        }

        viewStartDate = eventsArray[0].startDate;
        viewEndDate = eventsArray[eventsArray.length - 1].startDate;

        for (var i = 0; i < eventsArray.length; i++) {
          eventsArray[i].endDate = dateAdd(eventsArray[i].startDate, eventsArray[i].eventDuration, eventsArray[i].durationUnits);
          eventsArray[i].initialStartDate = eventsArray[i].startDate;
          eventsArray[i].initialEventDuration = eventsArray[i].eventDuration;
          eventsArray[i].initialDurationUnits = eventsArray[i].durationUnits;
          eventsArray[i].isDirty = false;
        }

        this._eventsArray = eventsArray;
        this._startingDate = viewStartDate;
        this._endingDate = viewEndDate;
        this._flag = true;
        this._zoomed = false;

        this.updateTimelineDuration(viewStartDate, viewEndDate);
        //ents(eventsArray, viewStartDate, viewEndDate);

        break;

      } else {
        viewEndDate = recurenceObject.endDate;
        viewStartDate = recurenceObject.startDate;

        var arrayStart = 0;
        var count = 0;
        for (var i = 0; i < weekDaysNumberArray.length; i++) {
          startWeekDayNumber = moment(start_date).day();
          selectedWeekDayNumber = moment().day(weekDaysNumberArray[i]);                      // get the weekday name from the array (e.g. 'Monday', 'Thursday',...)
          selectedWeekDayNumber = selectedWeekDayNumber.day();
          dayNumberOfAppearances = countSelectedWeekdayAppearance(start_date, recurenceObject.endDate, weekDaysNumberArray[i]);
          var startDate = getWeeklyEventStartDate(selectedWeekDayNumber, startWeekDayNumber, start_date);

          count = count + Math.ceil(dayNumberOfAppearances / recurenceObject.howOften);
          for (var j = arrayStart; j < count; j++) {
            eventsArray[j].startDate = moment(startDate).format();
            eventsArray[j].eventDuration = recurenceObject.eventDuration;
            eventsArray[j].durationUnits = recurenceObject.durationUnits;
            startDate = moment(startDate).add((recurenceObject.howOften * 7), 'days');
          }
          arrayStart = j;
        }

        eventsArray.sort(sortArray);
      }

      viewStartDate = eventsArray[0].startDate;
      viewEndDate = eventsArray[eventsArray.length - 1].startDate;

      for (var i = 0; i < eventsArray.length; i++) {
        eventsArray[i].endDate = dateAdd(eventsArray[i].startDate, eventsArray[i].eventDuration, eventsArray[i].durationUnits);
        eventsArray[i].initialStartDate = eventsArray[i].startDate;
        eventsArray[i].initialEventDuration = eventsArray[i].eventDuration;
        eventsArray[i].initialDurationUnits = eventsArray[i].durationUnits;
        eventsArray[i].isDirty = false;
      }

      this._eventsArray = eventsArray;
      this._startingDate = viewStartDate;
      this._endingDate = viewEndDate;
      this._flag = true;
      this._zoomed = false;

      this.updateTimelineDuration(viewStartDate, viewEndDate);
      //renderEvents(eventsArray, viewStartDate, viewEndDate);

      break;

    //              ***** M O N T H L Y *****
    case 'monthly':
      weekDaysNumberArray = [];
      var startDateOfSelectedDayOfMonth;
      var selectedDayWeekNumber;
      var weekNumber;
      var order;

      //=============================================================================
      if (isNaN(recurenceObject.when[0])) {      // 'recurence_pattern' seelcted is e.g. 'Every', 'The first', 'The second',... was selected

        var selectedDayWeekDate = moment().day(recurenceObject.when[1]);
        var selectedDayWeekNumber = moment(selectedDayWeekDate).day();
        var startDateOfMonth = moment(recurenceObject.startDate).startOf('month');
        var startDateOfMonthWeekNumber = startDateOfMonth.day();
        order = getOrder(recurenceObject);

        //=============================================================================
        if (recurenceObject.nrOfEvents) {                              // 'create X events' of range_of_recurence was selected (for NaN)

          for (i = 0; i < recurenceObject.nrOfEvents; i++) {           // number of selected days is greater than number of events
            eventsArray.push({});
          }

          if (order < 5) {                                             // one of 'every', 'first', 'second', 'third', 'fourth' was selected
            start_date = getStartDateForSelectedWeekday(recurenceObject);
            selectedDayNumber = moment(start_date).day();
            start_date = new Date(start_date);
            var start_month = start_date.getMonth();

            for (var i = 0; i < recurenceObject.nrOfEvents; i++) {          // get all events for the selected day of the week
              start_date = new Date(start_date);
              if (start_month == start_date.getMonth()) {
                eventsArray[i].startDate = moment(start_date).format();
                eventsArray[i].eventDuration = recurenceObject.eventDuration;
                eventsArray[i].durationUnits = recurenceObject.durationUnits;
                if (order == 0) {
                  start_date = moment(start_date).add(1, 'weeks');
                } else {
                  start_date = moment(start_date).add(recurenceObject.howOften, 'months');
                  var startDateOfMonth = moment(start_date).startOf('month');
                  var startDateOfMonthWeekNumber = startDateOfMonth.day();
                  if (i == 0) {
                    start_date = getTheNextEventDate(eventsArray[i].startDate, order, recurenceObject);
                  } else {
                    start_date = getTheNextEventDate(eventsArray[i - 1].startDate, order, recurenceObject);
                  }
                }

              } else {
                start_date = moment(eventsArray[i - 1].startDate).add(recurenceObject.howOften, 'months');
                var startDateOfMonth = moment(start_date).startOf('month');
                var startDateOfMonthWeekNumber = startDateOfMonth.day();
                if (i == 0) {
                  start_date = getTheNextEventDate(eventsArray[i].startDate, order, recurenceObject);
                } else {
                  start_date = getTheNextEventDate(eventsArray[i - 1].startDate, order, recurenceObject);
                }
                eventsArray[i].startDate = moment(start_date).format();
                eventsArray[i].eventDuration = recurenceObject.eventDuration;
                eventsArray[i].durationUnits = recurenceObject.durationUnits;
                start_date = new Date(start_date);
                start_month = start_date.getMonth();
                if (order == 0) {
                  start_date = moment(start_date).add(1, 'weeks');
                } else {
                  start_date = moment(start_date).add(recurenceObject.howOften, 'months');
                }
              }
            }                                             // End of - get all events for the selected day of the week
          }                                               // End of - one of 'every', 'first', 'second', 'third', 'fourth' was selected

          if (order >= 5) {                               // Either 'fifth' or 'last' were selected
            selectedDayWeekDate = moment().day(recurenceObject.when[1]);
            var selectedDayNumber = moment(selectedDayWeekDate).day();
            if (order == 5) {                             // Option 'fifth' was selected
              var valid = true;
              for (var i = 0; i < recurenceObject.nrOfEvents; i++) {
                valid = true;
                while (valid) {
                  start_date = new Date(startDateOfMonth);
                  var startYear = start_date.getFullYear();
                  var startMonth = start_date.getMonth();
                  var NumberOfDaysInMonth = moment(startDateOfMonth).daysInMonth();
                  if (NumberOfDaysInMonth > 28) {
                    for (j = 29; j <= NumberOfDaysInMonth; j++) {
                      startDateOfMonth = moment([startYear, startMonth, j]);
                      startDateOfMonth = new Date(startDateOfMonth);
                      var startingDate = new Date(recurenceObject.startDate);
                      var startDateNumber = moment(startDateOfMonth).day();
                      if ((startDateNumber == selectedDayNumber) && (moment(startDateOfMonth) >= moment(startingDate))) {
                        eventsArray[i].startDate = moment(startDateOfMonth).format();
                        eventsArray[i].eventDuration = recurenceObject.eventDuration;
                        eventsArray[i].durationUnits = recurenceObject.durationUnits;
                        valid = false;
                      }
                    }
                  }
                  startDateOfMonth = moment(startDateOfMonth).startOf('month');
                  startDateOfMonth = moment(startDateOfMonth).add((1 * recurenceObject.howOften), 'months');
                }
              }
            }                                       // End of - Option 'fifth' was selected

            if (order == 6) {                      // Option 'last' was selected
              var startDay = moment(recurenceObject.startDate).date();
              var limitDay = moment(recurenceObject.startDate).daysInMonth();
              start_date = new Date(recurenceObject.startDate);
              startYear = start_date.getFullYear();
              startMonth = start_date.getMonth();
              var j = 0;
              for (var i = startDay; i <= limitDay; i++) {
                var newDate = moment([startYear, startMonth, i]);
                var newDateNumber = moment(newDate).day();

                if (newDateNumber == selectedDayNumber) {
                  eventsArray[j].startDate = moment(newDate).format();
                  eventsArray[j].eventDuration = recurenceObject.eventDuration;
                  eventsArray[j].durationUnits = recurenceObject.durationUnits;
                  j++;

                }
              }

              for (var i = j; i < recurenceObject.nrOfEvents; i++) {
                startDateOfMonth = moment(startDateOfMonth).startOf('month');
                startDateOfMonth = moment(startDateOfMonth).add((1 * recurenceObject.howOften), 'months');
                NumberOfDaysInMonth = moment(startDateOfMonth).daysInMonth();
                start_date = new Date(startDateOfMonth);
                startYear = start_date.getFullYear();
                startMonth = start_date.getMonth();
                valid = true;

                while (valid) {
                  newDate = moment([startYear, startMonth, NumberOfDaysInMonth]);
                  newDateNumber = moment(newDate).day();
                  if (newDateNumber == selectedDayNumber) {
                    eventsArray[i].startDate = moment(newDate).format();
                    eventsArray[i].eventDuration = recurenceObject.eventDuration;
                    eventsArray[i].durationUnits = recurenceObject.durationUnits;
                    valid = false;
                  } else {
                    NumberOfDaysInMonth--;
                  }
                }
              }
            }                                     // End of - Option 'last' was selected
          }                                       // End of - Either 'fifth' or 'last' were selected
          //}

          viewStartDate = moment(eventsArray[0].startDate);
          viewEndDate = moment(eventsArray[eventsArray.length - 1].startDate);

          for (var i = 0; i < eventsArray.length; i++) {
            eventsArray[i].endDate = dateAdd(eventsArray[i].startDate, eventsArray[i].eventDuration, eventsArray[i].durationUnits);
            eventsArray[i].initialStartDate = eventsArray[i].startDate;
            eventsArray[i].initialEventDuration = eventsArray[i].eventDuration;
            eventsArray[i].initialDurationUnits = eventsArray[i].durationUnits;
            eventsArray[i].isDirty = false;
          }

          this._eventsArray = eventsArray;

          this._startingDate = viewStartDate;
          this._endingDate = viewEndDate;
          this._flag = true;
          this._zoomed = false;

          this.updateTimelineDuration(viewStartDate, viewEndDate);
          //renderEvents(eventsArray, viewStartDate, viewEndDate);
        }                                                       // End of - 'create X events' of range_of_recurence was selected (for NaN)

        //=============================================================================
        if (recurenceObject.nrOfEvents == '') {                  // A 'Repeat until' or 'no_end_date' has bin selected (for NaN)

          if (order < 5) {
            start_date = getStartDateForSelectedWeekday(recurenceObject);
            start_date = new Date(start_date);
            start_month = start_date.getMonth();
            var selectedDayNumber = moment(start_date).day();
            index = 0;

            var begin_date = moment(start_date).startOf('day');
            while (moment(begin_date) <= moment(viewEndDate)) {
              if (begin_date > viewEndDate) {
                break;
              }
              start_date = new Date(start_date);
              if (start_month == start_date.getMonth()) {
                eventsArray.push({});
                eventsArray[index].startDate = moment(start_date).format();
                eventsArray[index].eventDuration = recurenceObject.eventDuration;
                eventsArray[index].durationUnits = recurenceObject.durationUnits;
                index++;
                if (order == 0) {
                  start_date = moment(start_date).add(1, 'weeks');
                } else {
                  start_date = moment(start_date).add(recurenceObject.howOften, 'months');
                  var startDateOfMonth = moment(start_date).startOf('month');
                  var startDateOfMonthWeekNumber = startDateOfMonth.day();
                  if (index == 0) {
                    start_date = getTheNextEventDate(eventsArray[index].startDate, order, recurenceObject);
                  } else {
                    start_date = getTheNextEventDate(eventsArray[index - 1].startDate, order, recurenceObject);
                  }
                }
              } else {
                if (index == 0) {
                  start_date = moment(eventsArray[index].startDate).add(recurenceObject.howOften, 'months');
                } else {
                  start_date = moment(eventsArray[index - 1].startDate).add(recurenceObject.howOften, 'months');
                }
                var startDateOfMonth = moment(start_date).startOf('month');
                var startDateOfMonthWeekNumber = startDateOfMonth.day();
                if (index == 0) {
                  start_date = getTheNextEventDate(eventsArray[index].startDate, order, recurenceObject);
                } else {
                  start_date = getTheNextEventDate(eventsArray[index - 1].startDate, order, recurenceObject);
                }
                if (start_date > viewEndDate) {
                  break;
                }
                eventsArray.push({});
                eventsArray[index].startDate = moment(start_date).format();
                eventsArray[index].eventDuration = recurenceObject.eventDuration;
                eventsArray[index].durationUnits = recurenceObject.durationUnits;
                start_date = new Date(start_date);
                start_month = start_date.getMonth();
                if (order == 0) {
                  start_date = moment(start_date).add(1, 'weeks');
                } else {
                  start_date = moment(start_date).add(recurenceObject.howOften, 'months');
                }
                index++;
              }
            }
          }

          if (order >= 5) {                                                // Selected order is either 'fifth' or 'last'
            selectedDayWeekDate = moment().day(recurenceObject.when[1]);
            selectedDayNumber = moment(selectedDayWeekDate).day();
            if (order == 5) {                                              // Begin of selected 'fifth'
              i = 0;
              while (moment(startDateOfMonth) < moment(recurenceObject.endDate)) {
                start_date = new Date(startDateOfMonth);
                var startYear = start_date.getFullYear();
                var startMonth = start_date.getMonth();
                var NumberOfDaysInMonth = moment(startDateOfMonth).daysInMonth();
                if (NumberOfDaysInMonth > 28) {
                  for (j = 29; j <= NumberOfDaysInMonth; j++) {
                    startDateOfMonth = moment([startYear, startMonth, j]);
                    startDateOfMonth = new Date(startDateOfMonth);
                    var startingDate = new Date(recurenceObject.startDate);
                    var startDateNumber = moment(startDateOfMonth).day();
                    if ((startDateNumber == selectedDayNumber) && (moment(startDateOfMonth) >= moment(startingDate))) {
                      eventsArray.push({});
                      eventsArray[i].startDate = moment(startDateOfMonth).format();
                      eventsArray[i].eventDuration = recurenceObject.eventDuration;
                      eventsArray[i].durationUnits = recurenceObject.durationUnits;
                      i++;
                    }
                  }
                }
                startDateOfMonth = moment(startDateOfMonth).startOf('month');
                startDateOfMonth = moment(startDateOfMonth).add((1 * recurenceObject.howOften), 'months');
              }
            }                                                                           // End of selected 'fifth'

            if (order == 6) {                                                           // Start of selected 'last'
              selectedDayWeekDate = moment().day(recurenceObject.when[1]);
              selectedDayNumber = moment(selectedDayWeekDate).day();
              startDay = moment(recurenceObject.startDate).date();
              i = 0;

              while (moment(startDateOfMonth) <= moment(recurenceObject.endDate)) {     // Begin of WHILE
                start_date = new Date(startDateOfMonth);
                var startYear = start_date.getFullYear();
                var startMonth = start_date.getMonth();
                NumberOfDaysInMonth = moment(startDateOfMonth).daysInMonth();

                for (j = NumberOfDaysInMonth; j >= 20; j--) {
                  startDateOfMonth = moment([startYear, startMonth, j]);
                  startDateOfMonth = new Date(startDateOfMonth);
                  var startingDate = new Date(recurenceObject.startDate);
                  var startDateNumber = moment(startDateOfMonth).day();
                  if ((startDateNumber == selectedDayNumber) && (moment(startDateOfMonth) >= moment(startingDate))) {
                    eventsArray.push({});
                    eventsArray[i].startDate = moment(startDateOfMonth).format();
                    eventsArray[i].eventDuration = recurenceObject.eventDuration;
                    eventsArray[i].durationUnits = recurenceObject.durationUnits;
                    i++;
                    break;
                  }
                }
                startDateOfMonth = moment(startDateOfMonth).startOf('month');
                startDateOfMonth = moment(startDateOfMonth).add((1 * recurenceObject.howOften), 'months');
              }                                                               // End of WHILE
            }                                                                 // End of selected 'last'
          }                                                                   // End of - Selected order is either 'fifth' or 'last'


          if (eventsArray.length > 0) {
            viewStartDate = moment(eventsArray[0].startDate);
            viewEndDate = moment(eventsArray[eventsArray.length - 1].startDate);

            for (var i = 0; i < eventsArray.length; i++) {
              eventsArray[i].endDate = dateAdd(eventsArray[i].startDate, eventsArray[i].eventDuration, eventsArray[i].durationUnits);
              eventsArray[i].initialStartDate = eventsArray[i].startDate;
              eventsArray[i].initialEventDuration = eventsArray[i].eventDuration;
              eventsArray[i].initialDurationUnits = eventsArray[i].durationUnits;
              eventsArray[i].isDirty = false;
            }

            this._eventsArray = eventsArray;
            this._startingDate = viewStartDate;
            this._endingDate = viewEndDate;
            this._flag = true;
            this._zoomed = false;

            this.updateTimelineDuration(viewStartDate, viewEndDate);
            //renderEvents(eventsArray, viewStartDate, viewEndDate);

          } else {
            var untilDate = this.getFormField('.range_of_recurence input#repeat_until.form-control.date-field.datepick');
            untilDate[0].value = '';
          }                                                        // End of - A 'Repeat until' or 'no_end_date' has bin selected (for NaN)
        }
      }                                                             // End of - 'recurence_pattern' seelcted is e.g. 'Every', 'The first', 'The second',... was selected

      //=============================================================================
      if (!(isNaN(recurenceObject.when[0]))) {                     // 'recurence_pattern' seelcted is e.g. 01, 02, 29,...,31

        if (recurenceObject.nrOfEvents) {                          // 'create X events' of range_of_recurence was selected (for !isNaN)
          var arrayOfDays = [];
          for (var i = 0; i < recurenceObject.nrOfEvents; i++) {       // number of selected days is greater than number of events
            eventsArray.push({});
          }

          for (var i = 0; i < recurenceObject.when.length; i++) {      // find the start day dependent on the startDate (selected in the menu)
            if (moment(recurenceObject.startDate).date() <= recurenceObject.when[i]) {
              numberOfDays = recurenceObject.when[i] - moment(recurenceObject.startDate).date();
              start_date = moment(recurenceObject.startDate).add(numberOfDays, 'days');
              index = i;                                           // index of the found next day...
              found = true;
              break;
            }
          }

          if (!found) {
            var numberOfDaysInMonth = moment(recurenceObject.startDate).daysInMonth();
            numberOfDays = (numberOfDaysInMonth - recurenceObject.when[1]) + 1;
            start_date = moment(recurenceObject.startDate).add(numberOfDays, 'days');
            for (i = 0; i < recurenceObject.when.length; i++) {
              arrayOfDays.push({});
              arrayOfDays[i] = recurenceObject.when[i];
            }
          }

          if (found) {
            for (i = 0; i < recurenceObject.when.length; i++) {
              arrayOfDays.push({});
              arrayOfDays[i] = recurenceObject.when[i];
            }

            partOfArray = arrayOfDays.slice(index);
            for (j = 0; j < partOfArray.length; j++) {
              arrayOfDays.pop();
            }
            arrayOfDays = partOfArray.concat(arrayOfDays);
          }

          start_date = new Date(start_date);
          var start_year = start_date.getFullYear();
          start_month = start_date.getMonth();

          index = 0;
          var modulu = 0;
          var flag;

          for (var i = 0; i < eventsArray.length; i++) {
            flag = true;
            while (flag) {
              index = modulu % recurenceObject.when.length;
              if (modulu !== 0 && index == 0) {
                start_date = moment(start_date).add(1, 'months');
                start_date = new Date(start_date);
                start_year = start_date.getFullYear();
                start_month = start_date.getMonth();
              }
              if (dateIsValid(arrayOfDays[index], start_month, start_year)) {
                start = moment([start_year, start_month, arrayOfDays[index]]);
                start = new Date(start);
                start_date = new Date(start_date);
                if (start.getTime() < start_date.getTime()) {
                  start = getMonthlyEventStartDate(arrayOfDays[index], start_date)
                }

                eventsArray[i].startDate = getNewDateAndTime(start_date, start);
                eventsArray[i].eventDuration = recurenceObject.eventDuration;
                eventsArray[i].durationUnits = recurenceObject.durationUnits;
                modulu++;
                flag = false;
              } else {
                modulu++;
              }
            }
          }

          viewStartDate = moment(eventsArray[0].startDate);
          viewEndDate = moment(eventsArray[eventsArray.length - 1].startDate);

          for (var i = 0; i < eventsArray.length; i++) {
            eventsArray[i].endDate = dateAdd(eventsArray[i].startDate, eventsArray[i].eventDuration, eventsArray[i].durationUnits);
            eventsArray[i].initialStartDate = eventsArray[i].startDate;
            eventsArray[i].initialEventDuration = eventsArray[i].eventDuration;
            eventsArray[i].initialDurationUnits = eventsArray[i].durationUnits;
            eventsArray[i].isDirty = false;
          }

          this._eventsArray = eventsArray;
          this._startingDate = viewStartDate;
          this._endingDate = viewEndDate;
          this._flag = true;
          this._zoomed = false;

          this.updateTimelineDuration(viewStartDate, viewEndDate);
          //renderEvents(eventsArray, viewStartDate, viewEndDate);
        }                                                         // End of - 'create X events' of range_of_recurence was selected (for !isNaN)

        if (recurenceObject.nrOfEvents == '') {                  // A 'Repeat until' or 'no_end_date' has bin selected (for !isNaN)

          start_date = getStartDateForSelectedWeekday(recurenceObject);
          start_date = new Date(start_date);
          start_month = start_date.getMonth();
          selectedDayNumber = moment(start_date).day();
          index = 0;

          arrayOfDays = [];

          for (var i = 0; i < recurenceObject.when.length; i++) {      // find the start day dependent on the startDate (selected in the menu)
            if (moment(recurenceObject.startDate).date() <= recurenceObject.when[i]) {
              numberOfDays = recurenceObject.when[i] - moment(recurenceObject.startDate).date();
              start_date = moment(recurenceObject.startDate).add(numberOfDays, 'days');
              index = i;                                      // index of the found next day...
              found = true;
              break;
            }
          }

          if (!found) {
            numberOfDaysInMonth = moment(recurenceObject.startDate).daysInMonth();
            numberOfDays = (numberOfDaysInMonth - recurenceObject.when[1]) + 1;
            start_date = moment(recurenceObject.startDate).add(numberOfDays, 'days');
            for (i = 0; i < recurenceObject.when.length; i++) {
              arrayOfDays.push({});
              arrayOfDays[i] = recurenceObject.when[i];
            }
          }

          if (found) {
            for (i = 0; i < recurenceObject.when.length; i++) {
              arrayOfDays.push({});
              arrayOfDays[i] = recurenceObject.when[i];
            }

            partOfArray = arrayOfDays.slice(index);
            for (j = 0; j < partOfArray.length; j++) {
              arrayOfDays.pop();
            }
            arrayOfDays = partOfArray.concat(arrayOfDays);
          }

          start_date = new Date(start_date);
          var start_year = start_date.getFullYear();
          start_month = start_date.getMonth();

          index = 0;
          var start = 0;
          var eventArrayIndex = 0;

          viewEndDate = moment(recurenceObject.endDate);
          begin_date = new Date(recurenceObject.startDate);

          while (moment(start_date) < moment(viewEndDate)) {
            var x = index % recurenceObject.when.length;
            if (x == 0 && index == 0) {
              start = new Date(begin_date);
              start_year = start.getFullYear();
              start_month = start.getMonth();
              start = moment([start_year, start_month, recurenceObject.when[x]]);
              if (moment(start) > moment(viewEndDate)) {
                break;
              }
              if (start >= begin_date) {
                start_date = moment(start);
                if (dateIsValid(recurenceObject.when[x], start_month, start_year)) {
                  eventsArray.push({});
                  eventsArray[eventArrayIndex].startDate = moment(start).format();
                  eventsArray[eventArrayIndex].eventDuration = recurenceObject.eventDuration;
                  eventsArray[eventArrayIndex].durationUnits = recurenceObject.durationUnits;
                  start_date = moment(start);
                  eventArrayIndex++;
                }
              } else {
                start_date = moment(begin_date);
              }
            }

            if (x == 0 && index !== 0) {
              start = moment(start_date).add(1, 'months');
              start = new Date(start);
              start_year = start.getFullYear();
              start_month = start.getMonth();
              start = moment([start_year, start_month, recurenceObject.when[x]]);
              start_date = moment(start);
              if (moment(start) > moment(viewEndDate)) {
                break;
              }
              if (start >= begin_date) {
                if (dateIsValid(recurenceObject.when[x], start_month, start_year)) {
                  eventsArray.push({});
                  eventsArray[eventArrayIndex].startDate = moment(start).format();
                  eventsArray[eventArrayIndex].eventDuration = recurenceObject.eventDuration;
                  eventsArray[eventArrayIndex].durationUnits = recurenceObject.durationUnits;
                  start_date = moment(start);
                  eventArrayIndex++;
                }
              } else {
                start_date = moment(start);
              }
            } else {
              if (x !== 0) {
                start = moment([start_year, start_month, recurenceObject.when[x]]);
                if (moment(start) > moment(viewEndDate)) {
                  break;
                }
                if (start >= begin_date) {
                  if (moment(start) > moment(viewEndDate)) {
                    break;
                  }
                  if (dateIsValid(recurenceObject.when[x], start_month, start_year)) {
                    eventsArray.push({});
                    eventsArray[eventArrayIndex].startDate = moment(start).format();
                    eventsArray[eventArrayIndex].eventDuration = recurenceObject.eventDuration;
                    eventsArray[eventArrayIndex].durationUnits = recurenceObject.durationUnits;
                    start_date = moment(start);
                    eventArrayIndex++;
                  }
                  start_date = moment(start);
                }
              }
            }
            index++;
          }

          if (eventsArray.length > 0) {
            viewStartDate = moment(eventsArray[0].startDate);
            viewEndDate = moment(eventsArray[eventsArray.length - 1].startDate);

            for (var i = 0; i < eventsArray.length; i++) {
              eventsArray[i].endDate = dateAdd(eventsArray[i].startDate, eventsArray[i].eventDuration, eventsArray[i].durationUnits);
              eventsArray[i].initialStartDate = eventsArray[i].startDate;
              eventsArray[i].initialEventDuration = eventsArray[i].eventDuration;
              eventsArray[i].initialDurationUnits = eventsArray[i].durationUnits;
              eventsArray[i].isDirty = false;
            }

            this._eventsArray = eventsArray;
            this._startingDate = viewStartDate;
            this._endingDate = viewEndDate;
            this._flag = true;
            this._zoomed = false;

            this.updateTimelineDuration(viewStartDate, viewEndDate);
            //renderEvents(eventsArray, viewStartDate, viewEndDate);

          } else {
            untilDate = this.getFormField('.range_of_recurence input#repeat_until.form-control.date-field.datepick');
            untilDate[0].value = '';
          }
        } // A 'Repeat until' or 'no_end_date' has bin selected (for !isNaN)
      } // End of - 'recurence_pattern' seelcted is e.g. 01, 02, 29,...,31

  } // End of - SWITCH FOR DAILY, WEEKLY & MONTHLY
} // End of - Function to prepare events for rendering

//=============================================================================
// Function to get the weekly start date for an event
//=============================================================================
FullcalendarTimeline.prototype.getWeeklyEventStartDate = function (selectedWeekDayNumber, startWeekDayNumber, startDate) {

  var nrOfDays;
  var start_date;

  selectedWeekDayNumber = moment().day(selectedWeekDayNumber);
  selectedWeekDayNumber = moment(selectedWeekDayNumber).day();                    // get the weekday number of a selected weekday (e.g. Monday, Thursday,...)
  start_date = moment(startDate);                                         // calculate the start_date for the weekday to start events
  nrOfDays = selectedWeekDayNumber - startWeekDayNumber;                  // get the difference in days between the input startDate and the new weekday
  if (nrOfDays == 0) {
    start_date = moment(startDate);                                       // if '0' then it is the same day as the input startDate
  } else {
    if (nrOfDays > 0) {
      start_date = moment(start_date).add(nrOfDays, 'days');              // if event day is ahead from startDate, then add days to the input startDate
    } else {
      nrOfDays = (7 - startWeekDayNumber) + selectedWeekDayNumber;        // if input startDate is ahead
      start_date = moment(start_date).add(nrOfDays, 'days');              // add days to the selected weekday
    }
  }
  return start_date.format();
}

//=============================================================================
// Function to get the monthly start date for an event
//=============================================================================
FullcalendarTimeline.prototype.getMonthlyEventStartDate = function (selectedMonthDay, startDate) {
  startDate = new Date(startDate);

  var start_year = startDate.getFullYear();
  var start_month = startDate.getMonth();
  var day_of_month = startDate.getDate();
  if (day_of_month > selectedMonthDay) {
    var start_day = selectedMonthDay;
    var start_date = moment([start_year, start_month, start_day]);
    start_date = start_date.add(1, 'months');
  } else {
    start_day = selectedMonthDay;
    start_date = moment([start_year, start_month, start_day]);
    start_day = selectedMonthDay;
    start_date = moment([start_year, start_month, start_day]);
  }
  return start_date.format();
}

//=============================================================================
// Count the times a selected week day appearce between start and end date
//=============================================================================
FullcalendarTimeline.prototype.countSelectedWeekdayAppearance = function (startdate, enddate, selectedDayOfWeekNumber) {   // How many times a selected weekday  = function (e.g. Monday) appears
  var endDate = moment(enddate);
  var startDate = moment(startdate);                                  // The start date is when the selected weekday appears for the first time
  var diffDays = endDate.diff(startDate, 'days') + 2;                      // How many says between start and end date
  var nextDay = moment(startDate);
  var numberOfWeekDayInMonth = 0;

  //for (var i = 0; i <= diffDays; i++) {
  for (var i = 0; i < diffDays; i++) {                                  // Loop to find the number of times the selected weekday appears
    if (nextDay.day() === selectedDayOfWeekNumber)                    // Selected weekday found ?
    {
      numberOfWeekDayInMonth++;                                   // update counter
    }
    nextDay = nextDay.add(1, 'days');                              // move to next day. Needed to know if the day is the one searched
  }
  return numberOfWeekDayInMonth;                                    // return counter
}

//=============================================================================
// Get the start date for a selected week day
//=============================================================================
FullcalendarTimeline.prototype.getStartDateForSelectedWeekday = function (recurenceObject) {           // calculate the start date for the selected weekday
  var start_date = moment(recurenceObject.startDate);
  var firstDayOfMonthNumber = start_date.day();
  var selectedDayOfWeekNumber = moment().day(recurenceObject.when[1]);
  selectedDayOfWeekNumber = moment(selectedDayOfWeekNumber).day();

  var order = getOrder(recurenceObject);


  if (selectedDayOfWeekNumber == 0) {           // Sunday
    var addDays = 7 - firstDayOfMonthNumber;
    var new_date = moment(start_date).add(addDays, 'days');
    start_date = new Date(start_date);
    new_date = new Date(new_date);
    if (new_date.getTime() > start_date.getTime()) {
      if (order == 1) {
        new_date = getTheNextEventDate(moment(new_date), order, recurenceObject);
      }

    }

    if (order > 1) {
      var weekNumber = Math.ceil(moment(new_date).date() / 7);
      if (order > weekNumber) {
        addDays = order - weekNumber;
        new_date = moment(new_date).add(addDays * 7, 'days');
      }

      if (order < weekNumber) {
        new_date = getTheNextEventDate(moment(new_date), order, recurenceObject);
      }
    }
  }

  if (firstDayOfMonthNumber == selectedDayOfWeekNumber) {
    new_date = moment(start_date);
    weekNumber = Math.ceil(moment(new_date).date() / 7);
    if (order > weekNumber) {
      addDays = order - weekNumber;
      new_date = moment(new_date).add(addDays * 7, 'days');
    }

    if (order < weekNumber) {
      new_date = getTheNextEventDate(moment(new_date), order, recurenceObject);
    }

    if (order == 0) {
      return moment(start_date).format();
    }
  }

  if (firstDayOfMonthNumber > selectedDayOfWeekNumber && selectedDayOfWeekNumber !== 0) {
    var minusDays = firstDayOfMonthNumber - selectedDayOfWeekNumber;
    new_date = moment(start_date).subtract(minusDays, 'days');
    if (order == 0) {
      new_date = moment(new_date).add(7, 'days');
    }

    if (order == 1) {
      new_date = getTheNextEventDate(moment(new_date), order, recurenceObject);
    }

    if (order > 1) {
      weekNumber = Math.ceil(moment(new_date).date() / 7);
      if (order > weekNumber) {
        addDays = order - weekNumber;
        new_date = moment(new_date).add(addDays * 7, 'days');
      }

      if (order < weekNumber) {
        new_date = getTheNextEventDate(moment(new_date), order, recurenceObject);
      }

      if (order == weekNumber) {
        new_date = getTheNextEventDate(moment(new_date), order, recurenceObject);
      }
    }
  }

  if (firstDayOfMonthNumber < selectedDayOfWeekNumber) {
    addDays = selectedDayOfWeekNumber - firstDayOfMonthNumber;
    new_date = moment(start_date).add(addDays, 'days');

    weekNumber = Math.ceil(moment(new_date).date() / 7);
    if (order > weekNumber) {
      addDays = order - weekNumber;
      new_date = moment(new_date).add(addDays * 7, 'days');
    }

    if (weekNumber > order) {
      if (order > 0) {
        new_date = getTheNextEventDate(moment(new_date), order, recurenceObject);
      }
    }
  }

  return moment(new_date).format();
}

//=============================================================================
// Function to render events
//=============================================================================
FullcalendarTimeline.prototype.renderEvents = function (eventsArray, viewStartDate, viewEndDate) {     //Function is triggered by prepareEvents

  $('body').css({ 'cursor': 'wait' });

  // Remove existing 'highlighter' bars, before re-rendering
  if (this._timelineViewWrapper.find('.highlighter').length != 0) {
    this._timelineViewWrapper.find('.highlighter').remove();
  }

  this.tzOffset();

  var isRTL = (this._fullcalendarObject.getOption('dir') == 'rtl');
  var view = this._fullcalendarObject.view;

  var viewStartDate = new Date(view.currentStart);
  var viewEndDate = new Date(view.currentEnd);

  var viewStartTime = viewStartDate.getTime();
  var viewEndTime = viewEndDate.getTime();
  var viewDuration = viewEndTime - viewStartTime;


  for (var i = 0; i < eventsArray.length; i++) {
    var duration = eventsArray[i].eventDuration;
    var durationUnits = eventsArray[i].durationUnits;

    this._timelineViewWrapper.find('tbody.fc-body td.fc-time-area div.fc-scroller div.fc-scroller-canvas').prepend($('<div id="highlighter-' + i + '" class="highlighter" draggable="true"></div>'));

    var startDate = new Date(eventsArray[i].startDate)
    var width;

    view = this._fullcalendarObject.view;
    viewStartDate = new Date(view.currentStart);
    viewEndDate = new Date(view.currentEnd);
    viewStartTime = viewStartDate.getTime();
    viewEndTime = viewEndDate.getTime();
    viewDuration = viewEndTime - viewStartTime;
    width = this.setHighlighterBarWidth(duration, durationUnits)

    this._timelineViewWrapper.find('#highlighter-' + i).css('width', width);

    if (isRTL) {
      this._timelineViewWrapper.find('#highlighter-' + i).css('left', this.getEventWindowWidth() - ((((startDate.getTime() + this.tzOffset()) - viewStartTime) / viewDuration) * this.getEventWindowWidth()) - width);
    } else {
      this._timelineViewWrapper.find('#highlighter-' + i).css('left', (((startDate.getTime() - viewStartTime) / viewDuration) * this.getEventWindowWidth()));
      //this._timelineViewWrapper.find('#highlighter-' + i).css('left', (((startDate.getTime() + this.tzOffset()) - viewStartTime) / viewDuration) * this.getEventWindowWidth());
    }

  }

  // Mechanism to pass (this) to the handlers
  var fullCalendarTimelineObject = this;

  this._timelineViewWrapper.find('.highlighter').height(this.getEventWindowHeight());
  this._timelineViewWrapper.find('.highlighter').draggable({ axis: 'x' });
  this._timelineViewWrapper.find('.highlighter').resizable({ handles: 'e, w' });
  this._timelineViewWrapper.find('.highlighter').css('visibility', 'visible');

  this._timelineViewWrapper.find('.highlighter').on('drag', function (event, ui) {
    fullCalendarTimelineObject.onHighlighterBarUpdate(event, ui, $(this));
    fullCalendarTimelineObject.renderSelectedResources();
    fullCalendarTimelineObject.showTooltip(event, ui, $(this));
  });

  this._timelineViewWrapper.find('.highlighter').on('resize', function (event, ui) {
    fullCalendarTimelineObject.onHighlighterBarUpdate(event, ui, $(this));
    fullCalendarTimelineObject.renderSelectedResources();
    fullCalendarTimelineObject.showTooltip(event, ui, $(this));
  });

  this._timelineViewWrapper.find('.highlighter').on('mouseup', function (event, ui) {
    // after drag/resize operation
  });

  this._timelineViewWrapper.find('.highlighter').on('mouseenter', function (event, ui) {
    fullCalendarTimelineObject.showTooltip(event, ui, $(this));
  });

  this._timelineViewWrapper.find('.highlighter').on('mouseleave', function (event, ui) {
    fullCalendarTimelineObject.hideTooltip(event, ui, $(this));
  });

  this._timelineViewWrapper.find('.highlighter').on('dblclick', function (event, ui) {
    fullCalendarTimelineObject.dblclickEventZoomIn(event, ui, $(this));
  });

  $('body').css({ 'cursor': 'auto' });

}

FullcalendarTimeline.prototype.clearHighlighterConflicts = function () {
  if (typeof eventsArray !== 'undefined') {
    for (var eventArrayIndex = 0; eventArrayIndex < eventsArray.length; eventArrayIndex++) {
      eventsArray[eventArrayIndex].isInConflict = false;
    }
  }
}

FullcalendarTimeline.prototype.displayHighlighterConflicts = function () {
  if (typeof eventsArray !== 'undefined') {
    for (var eventArrayIndex = 0; eventArrayIndex < eventsArray.length; eventArrayIndex++) {
      // TODO: These values should come from the database
      var highlighter_color = (eventsArray[eventArrayIndex].isInConflict == true) ? 'rgba(255, 0, 0, 0.5)' : 'rgba(0, 255, 0, 0.5)';
      this._timelineViewWrapper.find('#highlighter-' + eventArrayIndex).css('background-color', highlighter_color);
    }
  }
}

//=============================================================================
// get start date for a daily event
//=============================================================================
function getDailyEventStartDate(start_date, howOften) {

  start_date = moment(start_date).add(howOften, 'days');
  start_date = moment(start_date).format();
  return start_date;
}

//=============================================================================
// get order of selected day, should it appear every week (zero for 'every',...) or the first day in a month ('1' for 'first',...)
//=============================================================================
function getOrder(recurenceObject) {
  var whichOrder = ['every', 'first', 'second', 'third', 'fourth', 'fifth', 'last'];
  var order = whichOrder.indexOf(recurenceObject.when[0]);
  return order;
}

//=============================================================================
// Get the next date the event should appear
//=============================================================================
function getTheNextEventDate(previousEventDate, order, recurenceObject) {

  previousEventDate = new Date(previousEventDate);
  var start_date;

  var daysInMonth = moment(previousEventDate).daysInMonth();
  var diffDays = daysInMonth - moment(previousEventDate).date();
  var modulu = diffDays % 7;
  modulu = 7 - modulu;

  if (modulu == 0) {
    if (order == 0) {
      start_date = moment(previousEventDate).add(diffDays + 7, 'days');
    }

    if (order == 1) {
      start_date = moment(previousEventDate).add(diffDays + 7, 'days');
      if (recurenceObject.howOften > 1) {
        start_date = getDateAfterNumberOfMonths(start_date, (recurenceObject.howOften - 1), order);
      }
    }

    if (order > 1) {
      start_date = moment(previousEventDate).add(diffDays + 7 + ((order - 1) * 7), 'days');
      if (recurenceObject.howOften > 1) {
        start_date = getDateAfterNumberOfMonths(start_date, (recurenceObject.howOften - 1), order);
      }
    }
  }

  if (modulu > 0) {
    if (order == 0) {
      start_date = moment(previousEventDate).add(diffDays + modulu, 'days');
      if (recurenceObject.howOften > 1) {
        start_date = getDateAfterNumberOfMonths(start_date, (recurenceObject.howOften - 1), order);
      }
    }

    if (order == 1) {
      start_date = moment(previousEventDate).add(diffDays + modulu, 'days');
      if (recurenceObject.howOften > 1) {
        start_date = getDateAfterNumberOfMonths(start_date, (recurenceObject.howOften - 1), order);
      }
    }

    if (order > 1) {
      start_date = moment(previousEventDate).add(diffDays + modulu + ((order - 1) * 7), 'days');
      if (recurenceObject.howOften > 1) {
        start_date = getDateAfterNumberOfMonths(start_date, (recurenceObject.howOften - 1), order);
      }
    }
  }

  return moment(start_date).format();
}

//=============================================================================
// Get the difference in days between two dates
//=============================================================================
function getTwoDatesDifference(date1, date2) {
  date1 = new Date(date1);
  date2 = new Date(date2);
  var timeDiff = Math.abs(date2.getTime() - date1.getTime());
  var diffHours = Math.ceil(timeDiff / (1000 * 3600));
  return diffHours;
}

//=============================================================================
// Find the next date for the event after 1 month, 2, 3,...
//=============================================================================
function getDateAfterNumberOfMonths(currentDate, numberOfMonths, order) {

  if (numberOfMonths == 0) {
    weekNumber = Math.ceil(moment(currentDate).date() / 7);
  }

  new_date = moment(currentDate);

  for (var i = 0; i < numberOfMonths; i++) {
    var daysInMonth = moment(new_date).daysInMonth();
    var diffDays = daysInMonth - moment(new_date).date();
    var modulu = diffDays % 7;
    modulu = 7 - modulu;
    var addDays = diffDays + modulu;
    var new_date = moment(new_date).add(addDays, 'days');
    var weekNumber = Math.ceil(moment(new_date).date() / 7);
    if (order > weekNumber) {
      addDays = order - weekNumber;
      new_date = moment(new_date).add(addDays * 7, 'days');
    }
  }

  return new_date;
}

//=============================================================================
// Get number of days to the next event date
//=============================================================================
function getNumberOfDaysToNewDate(currentDate, numberOfMonths, order) {

  for (var i = 0; i < numberOfMonths; i++) {
    var daysInMonth = moment(currentDate).daysInMonth();
    var diffDays = daysInMonth - moment(currentDate).date();
    var modulu = diffDays % 7;
    modulu = 7 - modulu;
    var addDays = diffDays + modulu + ((order - 1) * 7);
    var new_date = moment(currentDate).add(addDays, 'days');
  }

  return new_date;
}

//=============================================================================
// Sort function
//=============================================================================
function sortArray(a, b) {
  const startDateA = a.startDate.toUpperCase();
  const startDateB = b.startDate.toUpperCase();

  let comparison = 0;
  if (startDateA > startDateB) {
    comparison = 1;
  } else if (startDateA < startDateB) {
    comparison = -1;
  }
  return comparison;
}

//=============================================================================
// Set the time in the selected date
//=============================================================================
function getNewDateAndTime(start_date, start) {
  start_date = new Date(start_date);
  var hours = start_date.getHours();
  var minutes = start_date.getMinutes();
  start = new Date(start);
  start = start.setHours(hours);
  start = new Date(start);
  start = start.setMinutes(minutes);
  return moment(start).format();
}

function dateIsValid(selectedDay, month, year) {
  var date = moment([year, month, 1]);
  var daysInMonth = moment(date).daysInMonth();
  return (selectedDay <= daysInMonth);
}

//==================================================================
function getDurationInUnits(eventDurationHours, durationUnits) {
  var duration;

  switch (durationUnits) {
    case 'day':
      duration = (eventDurationHours / 24).toFixed(2);
      break;
    case 'hour':
      duration = (eventDurationHours).toFixed(2);
      break;
    case 'minute':
      duration = Math.round(eventDurationHours * 60);
      break;
    default:
      duration = Math.round(eventDurationHours * 60);
  }
  return duration;
} // End of getDurationInUnits
