//
// FullcalendarTimeline - Tool-tip and Zoom handlers
//

// Initialise i18n controls/data
FullcalendarTimeline.prototype.initialiseHighlighterbarTooltip = function () {
    // Mechanism to pass (this) to the handlers
    var fullCalendarTimelineObject = this;

    this._timelineViewWrapper.find('tbody.fc-body td.fc-time-area.fc-widget-content div.fc-scroller-clip  div.fc-scroller div.fc-scroller-canvas').prepend($('<span id="highlighter-tooltip" class="highlighter-tooltip">our tooltip</span>'));
    //$('#fullcalendar_scheduler tbody.fc-body td.fc-time-area div.fc-scroller div.fc-scroller-canvas').prepend($('<span id="highlighter-tooltip" class="highlighter-tooltip">our tooltip</span>'));
    this._tooltip = this._timelineViewWrapper.find('#highlighter-tooltip');

    window.onmousemove = function (e) {
        var tooltipSpan = fullCalendarTimelineObject._tooltip;
        var x = e.clientX,
            y = e.clientY;
        if (tooltipSpan) {
            tooltipSpan[0].style.top = y + 'px';
            tooltipSpan[0].style.left = x + 20 + 'px';
        }
    };
}

FullcalendarTimeline.prototype.showTooltip = function (event, ui, obj) {
    var id = obj.attr('id');
    var eventIndex = id.split('-')[1];
    var startDate = formatDate(new Date(this._eventsArray[eventIndex].startDate));
    var eventDuration = this._eventsArray[eventIndex].eventDuration;
    var durationUnits = this._eventsArray[eventIndex].durationUnits;
    var endDate = formatDate(new Date(this._eventsArray[eventIndex].endDate));

    var tooltipText =
        '<small>Start: </small>' + startDate + '<br/>' +
        '<small>Duration: </small>' + eventDuration + ' ' + durationUnits + '<br/>';

    if (!this._zoomed) {
        this._tooltip.html(tooltipText + '<em>double click to zoom in!</em>');
    } else {
        this._tooltip.html(tooltipText);
    }

    this._tooltip.css('visibility', 'visible');
}

FullcalendarTimeline.prototype.hideTooltip = function (event, ui, obj) {
    this._tooltip.css('visibility', 'hidden');
}

FullcalendarTimeline.prototype.dblclickEventZoomIn = function (event, ui, obj) {
    var id = obj.attr('id');
    var eventIndex = id.split('-')[1];
    var startDate = formatDate(new Date(this._eventsArray[eventIndex].startDate));
    var eventDuration = this._eventsArray[eventIndex].eventDuration;
    var durationUnits = this._eventsArray[eventIndex].durationUnits;
    var endDate = formatDate(new Date(this._eventsArray[eventIndex].endDate));

    if (!this._zoomed) {
        this.updateTimelineDuration(startDate, endDate);
        this._zoomed = true;
    }
}