var formData = {};
var iCalData = {};

$(document).ready(function () {
  $("table.recurring_event_data.no_repeat").show(); //'slow');
  var selected_recurrence = $("select#resource_planner_event_rrule").val();

  // clear all fields
  clearFields(selected_recurrence);

  //
  // common fields
  //

  // title
  $(formField().SUMMARY).on('change', function () {
    formUpdateHandler();
  });

  $(formField().SUMMARY).on('input', function () {
    formUpdateHandler();
  });

  // description
  $(formField().DESCRIPTION).on('change', function () {
    formUpdateHandler();
  });

  $(formField().DESCRIPTION).on('input', function () {
    formUpdateHandler();
  });

  // start_date
  $(formField().DTSTART).on('change', function () {
    formUpdateHandler();
  });

  $(formField().DTSTART).on('input', function () {
    formUpdateHandler();
  });

  $('#resource_planner_event_dtstart_timezone').on('change', function () {
    formUpdateHandler();
  });

  $('#resource_planner_event_dtstart_timezone').on('input', function () {
    formUpdateHandler();
  });

  // duration
  $(formField().DURATION).on('change', function () {
    formUpdateHandler();
  });

  $(formField().DURATION).on('input', function () {
    formUpdateHandler();
  });

  $(formField().DURATION_UNITS).on('change', function () {
    formUpdateHandler();
  });

  // resource_planner_event_rrule
  $('#resource_planner_event_rrule').on('change', function () {
    formUpdateHandler();
  });

  $('#resource_planner_event_rrule').on('input', function () {
    formUpdateHandler();
  });

  //
  // no_repeat fields
  //

  // end_date
  $(formField().DTEND).on('change', function () {
    formUpdateHandler();
  });

  $(formField().DTEND).on('input', function () {
    formUpdateHandler();
  });

  $('#resource_planner_event_dtend_timezone').on('change', function () {
    formUpdateHandler();
  });

  $('#resource_planner_event_dtend_timezone').on('input', function () {
    formUpdateHandler();
  });

  //
  // recurence_pattern fields
  //
  $('.day_buttons label').on('click', function () {
    var checkbox = $(this).prev('input:checkbox:first');
    if (checkbox.is(':checked')) {
      // it is currently checked, un-ckeck it
      checkbox.prop("checked", false);
      $(this).removeClass('day-button-selected');
    } else {
      // it is currently un-checked, ckeck it
      checkbox.prop("checked", true);
      $(this).addClass('day-button-selected');
    }
  });

  $('.monthly_day_buttons label').on('click', function () {
    var checkbox = $(this).prev('input:checkbox:first');
    if (checkbox.is(':checked')) {
      // it is currently checked, un-ckeck it
      checkbox.prop("checked", false);
      $(this).removeClass('day-button-selected');
    } else {
      // it is currently un-checked, ckeck it
      checkbox.prop("checked", true);
      $(this).addClass('day-button-selected');
    }
  });

  $('.recurring_event_data input').on('change', function () {
    formUpdateHandler();
  });

  $('.recurring_event_data label').on('click', function () {
    formUpdateHandler();
  });

  //
  // range_of_recurence fields
  //
  $('.range_of_recurence input').on('change', function () {
    formUpdateHandler();
  });

  // Submit button handler
  $('input[type=submit]').on('click', function () {
    submitButtonHandler();
  });

  // Initialise...
  formUpdateHandler();

});  // end $(document).ready

$(function () {
  $("select#resource_planner_event_rrule").on("change", function () {
    $("table.recurring_event_data").hide(); //'slow');
    $("table.range_of_recurence").hide(); //'slow');

    var selected_recurrence = $("select#resource_planner_event_rrule").val();
    clearFields(selected_recurrence);       // clear all fields of previous screens...
    if (selected_recurrence) {
      $("table.recurring_event_data." + selected_recurrence).show(); //'slow');
      if (selected_recurrence !== "no_repeat") {
        $("table.range_of_recurence").show(); //'slow');
      }
    }

    window.startingDate = $.trim($(formField().DTSTART).val());
    if (window.startingDate == "") {
      window.startingDate = moment().format();
      $.trim($(formField().DTSTART).val(moment(window.startingDate).format()));
    }
    window.endingDate = window.startingDate;
    updateTimelineDuration(window.startingDate, window.endingDate);

    return false;
  });

});

// Capture form fields -> 'window' data
function formUpdateHandler() {
  captureFormData();
  //validateFormData();
  updateIcalData();
  //prepareEventsArray();
  //renderEvents();
}

/**
 * Capture form fields -> formData
 */
function captureFormData() {

  formData.title = $.trim($(formField().SUMMARY).val());
  formData.description = $.trim($(formField().DESCRIPTION).val());

  formData.start_date = $.trim($(formField().DTSTART).val());
  formData.resource_planner_event_dtstart_timezone = $.trim($('#resource_planner_event_dtstart_timezone').val());

  formData.duration = $.trim($(formField().DURATION).val());
  formData.duration_units = $.trim($(formField().DURATION_UNITS).val());

  formData.resource_planner_event_rrule = $.trim($('#resource_planner_event_rrule').val());

  // no_repeat fields
  formData.end_date = $.trim($(formField().DTEND).val());
  formData.resource_planner_event_dtend_timezone = $.trim($('#resource_planner_event_dtend_timezone').val());

  // daily fields
  formData.resource_planner_event_count_every_n_days = $('#resource_planner_event_count_every_n_days')[0].checked;
  formData.resource_planner_event_count_every_weekday = $('#resource_planner_event_count_every_weekday')[0].checked;
  formData.resource_planner_event_count = $.trim($('#resource_planner_event_count').val());

  // weekly fields
  //resource_planner_event_count (See above.... In the 'weekly' case, it always refers to 'every n weeks')
  var selected_weekdays = '';
  $('.recurring_event_data.weekly .day_buttons input[type=checkbox]').each(function (index) {
    if ($(this)[0].checked) {
      var name = $(this)[0].name;
      var day = name.substring(name.lastIndexOf("[") + 1, name.lastIndexOf("]"));
      selected_weekdays = selected_weekdays + day + '/';
    }
  });
  formData.selected_weekdays = selected_weekdays.substring(0, selected_weekdays.length - 1);


  // monthly fields
  formData.resource_planner_event_count_every_month = $('#resource_planner_event_count_every_month')[0].checked;
  //resource_planner_event_count (See above.... In the 'monthly' case, it always refers to 'every n months')
  formData.resource_planner_event_bymonthday = $.trim($('#resource_planner_event_bymonthday').val());
  formData.resource_planner_event_bymonthday_day = $.trim($('#resource_planner_event_bymonthday_day').val());

  formData.resource_planner_event_count_every_month_day = $('#resource_planner_event_count_every_month_day')[0].checked;
  var selected_days_of_month = '';
  $('.recurring_event_data.monthly .monthly_day_buttons input[type=checkbox]').each(function (index) {
    if ($(this)[0].checked) {
      var name = $(this)[0].name;
      var date = name.substring(name.lastIndexOf("[") + 1, name.lastIndexOf("]"));
      selected_days_of_month = selected_days_of_month + date + '/';
    }
  });
  formData.selected_days_of_month = selected_days_of_month.substring(0, selected_days_of_month.length - 1);


  // range_of_recurence fields
  formData.resource_planner_event_until_no_end_date = $('#resource_planner_event_until_no_end_date')[0].checked;
  formData.resource_planner_event_until_create_n_events = $('#resource_planner_event_until_create_n_events')[0].checked;
  formData.resource_planner_event_until_count = $.trim($('#resource_planner_event_until_count').val());
  formData.resource_planner_event_until_repeat_until = $('#resource_planner_event_until_repeat_until')[0].checked;
  formData.repeat_until = $.trim($('#repeat_until').val());

}

/**
 * Convert formData into iCalData
 */
function updateIcalData() {
  // This could be performed on the server-side
}

// Submit button
function submitButtonHandler() {
  // Show summary
  var msg = "Event will be created:\n" +
    "Start    :" + formData.start_date + "(" + window.startingDate + ")\n" +
    "End      :" + formData.end_date + "(" + window.endingDate + ")\n" +
    "Resources:\n" +
    selectedResources;
  alert(msg);
  //alertDialog.show(msg);

  var data = {};
  data.formData = formData;
  data.resources = selectedResources;
  data.eventsArray = eventsArray;

  // //Passing mdate and phone variables to rails controller(book_date & phone)
  // window.open("localhost:3000//controller/create?mdate="+mdate+"&phone="+phone,"_self")
  //
  // -- OR --
  //

  /* Send the data using an ajax-post */
  $.ajax({
    //headers: { 'X-CSRF-Token': $('meta[name="csrf-token"]').attr('content') },
    url: '/resource_planner/events',
    type: 'POST',
    data: JSON.stringify(data),
    contentType: 'application/json',
    success: function (data, textStatus, jqXHR) {
      //alert('Complete: ' + textStatus);
      $('#fullcalendar_scheduler').fullCalendar('rerenderEvents');
    },
    created: function (data, textStatus, jqXHR) {
      //alert('Complete: ' + textStatus);
      $('#fullcalendar_scheduler').fullCalendar('rerenderEvents');
    },
    ok: function (data, textStatus, jqXHR) {
      //alert('Complete: ' + textStatus);
      $('#fullcalendar_scheduler').fullCalendar('rerenderEvents');
    },
    done: function (data, textStatus, jqXHR) {
      //alert('Complete: ' + textStatus);
      $('#fullcalendar_scheduler').fullCalendar('rerenderEvents');
    },
    error: function (data, textStatus, jqXHR) {
      //alert('Error: ' + textStatus);
    },
  });

  //
  // -- OR --
  //
  // // construct an HTTP request
  // var xhr = new XMLHttpRequest();
  // xhr.open(form.method, form.action, true);
  // xhr.setRequestHeader('Content-Type', 'application/json; charset=UTF-8');
  //
  // // send the collected data as JSON
  // xhr.send(JSON.stringify(data));
  //
  // xhr.onloadend = function () {
  //   // done
  // };
  //

}


//================================================================================================
// clear all fields

function clearFields(selected_recurrence) {
  $('.highlighter').remove();
  $('#highlighter').remove();

  window.startingDate = undefined;
  window.endingDate = undefined;
  window.eventsArray = [];

  var start_date = $.trim($(formField().DTSTART).val());
  if (start_date == "") {
    $(formField().DTSTART).addClass("input_warning");
  } else {
    $(formField().DTSTART).removeClass("input_warning");
  }

  $.trim($(formField().DURATION).val(""));
  if (selected_recurrence !== "no_repeat") {
    $(formField().DURATION).addClass("input_warning");
    $("table.range_of_recurence").show(); //'slow');
  } else {
    $.trim($(formField().DURATION).val(""));
    $.trim($(formField().DTEND).val(""));
    $(formField().DURATION).addClass("input_warning");
    $(formField().DTEND).addClass("input_warning");
  }

  // Clear DAILY Fields
  var buttonChecked = $('.recurring_event_data.daily input#resource_planner_event_count_every_n_days');
  buttonChecked[0].checked = false;
  $('.recurring_event_data.daily input#resource_planner_event_count').val("");
  buttonChecked = $('.recurring_event_data.daily input#resource_planner_event_count_every_weekday');
  buttonChecked[0].checked = false;

  $(".recurring_event_data.daily").addClass("input_warning");

  // Clear WEEKLY Fields
  $('.recurring_event_data.weekly input').val("");

  $('.recurring_event_data.weekly .day_buttons input[type=checkbox]').each(function (index) {
    $(this)[0].checked = false;
  });
  $('.day-button-selected').removeClass('day-button-selected');

  $(".recurring_event_data.weekly").addClass("input_warning");

  // Clear MONTHLY Fields
  buttonChecked = $('.recurring_event_data.monthly input#resource_planner_event_count_every_month');
  buttonChecked[0].checked = false;
  $('.recurring_event_data.monthly input#resource_planner_event_count').val("");
  var selectedCheckedButton = $('.recurring_event_data.monthly input#resource_planner_event_count_every_month_day');   // is the day_of_month button checked ?
  selectedCheckedButton[0].checked = false;

  $('.recurring_event_data.monthly .monthly_day_buttons input[type=checkbox]').each(function (index) {
    $(this)[0].checked = false;
  });
  var selectedMonthDays = $('.recurring_event_data.monthly label.day-button-selected');
  selectedMonthDays.removeClass('day-button-selected');

  $(".recurring_event_data.monthly").addClass("input_warning");

  document.getElementById("resource_planner_event_until_no_end_date").checked = false;
  document.getElementById("resource_planner_event_until_create_n_events").checked = false;
  $("#resource_planner_event_until_count").val("");

  document.getElementById("resource_planner_event_until_repeat_until").checked = false;

  $(".range_of_recurence").addClass("input_warning");

} // clear all fields
