json.array!(@events) do |event|
  date_format = event.all_day? ? '%Y-%m-%d' : '%Y-%m-%dT%H:%M:%S'

  json.extract! event, :id
  json.title event.name
  json.description event.name
  json.allDay event.all_day?
  json.start event.start_at.strftime(date_format) if event.start_at
  json.end event.end_at.strftime(date_format) if event.end_at
  #json.url event_url(event, :format => :html)
  json.url event_url(event, :format => :json)

  #json.className
  #json.editable
  #json.startEditable
  #json.durationEditable
  #json.resourceEditable
  #json.rendering
  #json.overlap
  #json.constraint
  #json.color
  #json.backgroundColor
  #json.borderColor
  #json.textColor

  resource_ids = Array.new
  event.event_subscriptions.each do |event_subscription|
    resource_ids.push( "#{event_subscription.resource_type}-#{event_subscription.resource.id}-#{event_subscription.resource.quantity}" )
  end
  json.resourceIds resource_ids
end
